<?php 

// +------------------------------------------------------------------+
// |                                                                  |
// | Copyright 1999-Present Kryptronic, Inc. All rights reserved.     |
// |                                                                  |
// | This software is copyrighted, trademarked, developed and         |
// | licensed by Kryptronic, Inc. This software is distributed        |
// | under license.                                                   |
// |                                                                  |
// | View the license agreement for more information.  Installation   |
// | of this software package indicates acceptance of the license     |
// | agreement.                                                       |
// |                                                                  |
// +------------------------------------------------------------------+

// +------------------------------------------------------------------+
// | IF INSTRUCTED TO EDIT THE $main_path_force VARIABLE, EDIT THE    |
// | VALUE BETWEEN THE SINGLE QUOTES ON THE FOLLOWING LINE.           |
// +------------------------------------------------------------------+

$main_path_force   = '';

$perms_level_files  = '777';
$perms_level_dirs   = '777';
$perms_level_exec   = '777';

// +------------------------------------------------------------------+
// | DO NOT EDIT BELOW THIS LINE.                                     |
// +------------------------------------------------------------------+

// +--
// | The following parameters are to be left alone.  We initially set
// | this script up to handle its own errors, run using the BackEnd
// | interface and to produce output (so we can use CORE_Error).  Right
// | before this script prints displays, we turn output off and destroy
// | the CORE_Display output buffer.
// +--

$interface = 'BackEnd';
$output    = 1;
$errhandle = 1;

// +--
// | Enter the importer script name if it has been changed.  We also
// | set the script up as a robot so cookies are not printed.
// +--

$importer_script = 'importer-europacart8-ccp6.php';
$importer_name   = 'ClickCartPro 6';
$robot           = 'Kryptronic Data Importer: ' . $importer_name;

// +--
// | Set permissions level for executable files and 
// | dirs to the same level as this file.
// +--

$thisfile = __FILE__;

while (preg_match('/\\\\/',$thisfile)) {$thisfile = preg_replace('/\\\\/','/',$thisfile);}

while (preg_match('/\/\//',$thisfile)) {$thisfile = preg_replace('/\/\//','/',$thisfile);}

$thisfile = preg_replace('/\/$/','',$thisfile);

$thisfile_perms = @substr(@decoct(@fileperms($thisfile)),3);

if ((!(empty($thisfile_perms))) && ($thisfile_perms == 755)) {

     $perms_level_exec = $thisfile_perms;

} // End of if statement.

// +--
// | Main program loader.  This object call creates an instance
// | of the COREmain class.  When the exec() function runs, the
// | program runs and produces output.  We exit() afterwards.
// +--

$coremain = new COREmain;

$coremain->exec(array('core.main_path_force'    => $main_path_force,
                      'core.interface'          => $interface,
                      'core.output'             => $output,
                      'core.errhandle'          => $errhandle,
                      'core.perms_level_files'  => $perms_level_files,
                      'core.perms_level_dirs'   => $perms_level_dirs,
                      'core.perms_level_exec'   => $perms_level_exec,
                      'importer.script_name'    => $importer_script,
                      'importer.name'           => $importer_name,
                      'core.robot'              => $robot));

// +--
// | Exit() is called from within the core during it's shutdown
// | function, however it's good practice to call it here as well
// | to handle garbage collection.
// +--

exit();

// +------------------------------------------------------------------+
// | Class Definition                                                 |
// +------------------------------------------------------------------+

class COREmain {

// +--
// | This class is used to verify the PHP environment we're running
// | in, load and execute the CORE class and provide error handling
// | outside of the scope of the main core class.
// +--

// +------------------------------------------------------------------+
// | Class Variables                                                  |
// +------------------------------------------------------------------+

var $class   = 'COREmain';
var $version = '8.0.0';
var $cerror;

// +------------------------------------------------------------------+
// | Constructor Function                                             |
// +------------------------------------------------------------------+

function COREmain () {

// +--
// | This is the constructor function.  This function starts up the
// | class.  Any pre-load variable assignments go here.
// +--

// +--
// | Return object.
// +--

return $this;

} // End of function.

// +------------------------------------------------------------------+
// | Function: exec                                                   |
// +------------------------------------------------------------------+

function exec ($input = array()) {

// +--
// | This routine is run to run the internals of the class.  Main class
// | logic is contained in this function.
// +--

// +--
// | Globalize our input array.
// +--

if (!(empty($input))) {

     foreach ($input as $key => $value) {$this->globals($key,$value);}

} // End of if statement.

// +--
// | Set error handling up to output errors to the browser.  We handle
// | all errors except for E_NOTICE errors.
// +--

ini_set('display_errors','1');

error_reporting(E_ALL ^ E_NOTICE);

set_error_handler(array(&$this,'error_display'));

// +--
// | Determine the directory from where we're running this program.
// +--

$path = $this->globals('core.main_path_force');

if ((!(empty($path))) && (@file_exists($path))) {

     $path = $this->globals('core.main_path_force');

} elseif (@file_exists(dirname(__FILE__))) {

     $path = dirname(__FILE__);

} elseif (@file_exists(getcwd())) {

     $path = getcwd();

} elseif (@file_exists(dirname($_SERVER['PATH_TRANSLATED']))) {

     $path = dirname($_SERVER['PATH_TRANSLATED']);

} elseif (@file_exists(dirname($_SERVER['SCRIPT_FILENAME']))) {

     $path = dirname($_SERVER['SCRIPT_FILENAME']);

} else {

     $errstr = "

     <p>This script could not determine the directory from which it is 
     being executed.  You need to edit the scripts 'index.php', 'admin.php' 
     and 'installer.php' and enter a value for the \$main_path_force 
     variable at the top of those scripts. Follow the instructions in each of 
     those scripts for more information.</p>

     <p>If you have already edited the \$main_path_force variable and are 
     seeing this message again, the value you used for that variable 
     appears to be incorrect.  Please try again.</p>

     ";

     trigger_error($errstr,E_USER_ERROR);

} // End of if statement.

// +--
// | Format our working directory we've just determined and globalize it.
// +--

$path = $this->paths_convert($path);

$this->globals('core.main_path_force',$path);

// +--
// | Include our config.php in the public directory.  Globalize the 
// | config array.
// +--

if (@file_exists($this->globals('core.main_path_force') . '/config.php')) {

     include($this->globals('core.main_path_force') . '/config.php');

     foreach ($config as $key => $value) {$this->globals($key,$value);}

     unset($config);

} // End of if statement.

// +--
// | If the $config array key 'core.path_private' was not defined,
// | we had a problem and need to error out.
// +--

$pathpriv = $this->globals('core.path_private');

if (empty($pathpriv)) {

     $errstr = "

     <p>It appears you have not run the core 
     installer script.  You need to run the installer script before
     accessing this script.</p>

     <p><a href=\"installer.php\" title=\"Installer\">Click here to run
     the installer script.</a></p>

     ";

     trigger_error($errstr,E_USER_ERROR);

} // End of if statement.

// +--
// | Our private config file will be included automatically
// | by the core when it loads up.
// |
// | Now that we have our public config file included,
// | we can include our main core file.
// +--

$privpath = $this->globals('core.path_private');

if (@file_exists($privpath . '/core/CORE/CORE.php')) {

     include_once($privpath . '/core/CORE/CORE.php');

// +--
// | If there is a problem finding the file, we error out.
// +--

} else {

     $errstr = "

     <p>This script could not locate the file 'CORE.php' in the
     directory:</p>

     <p>{$privpath}/core/CORE</p>

     <p>This could be the result of an incomplete installation.  The
     configuration files created by the installer appear to be complete, 
     however the installation of the codebase is incomplete.  This is a
     fatal error that cannot be resolved automatically.  Reinstall the
     software to continue.</p>

     <p><a href=\"installer.php\" title=\"Installer\">Click here to run
     the installer script.</a></p>

     ";

     trigger_error($errstr,E_USER_ERROR);

} // End of if statement.

// +--
// | If we were able to include our main core file, we can run the core.
// | Above we set 'output' to '0' and 'errhandle' to '1' so the core will 
// | produce no output and not trigger errors internally.  There is no need 
// | to check for errors at this level.  
// |
// | Create the CORE object.
// +--

global $xglobal_cache;

$core = new CORE($xglobal_cache);

if ($core->IsError($core->cerror)) {

     trigger_error($core->cerror->GetMessage(),E_USER_ERROR);

} // End of if statement.

// +--
// | Run the importer.  We pass it's constructor a reference to our
// | CORE object.
// +--

$importer = new COREimporter($core);

if ($core->IsError($importer->cerror)) {

     trigger_error($importer->cerror->GetMessage(),E_USER_ERROR);

} // End of if statement.

$importer->exec();

// +--
// | Run core shutdown method.
// +--

$core->shutdown();

// +--
// | Return true.
// +--

return 1;

} // End of function.

// +------------------------------------------------------------------+
// | Function: globals                                                |
// +------------------------------------------------------------------+

function globals ($name = '',$value = null,$default = null) {

// +--
// | This function maintains a global array of global variables for
// | use within the program.  Global variables can be set, changed and
// | obtained from this function.
// +--

global $xglobal_cache;

// +--
// | If the request contained a default identifier (passed as a true
// | value), we set a default value if the global doesn't exist.
// +--

if ((!(empty($name))) && (isset($value)) && (isset($default)) && (!(isset($xglobal_cache[$name])))) {

     $xglobal_cache[$name] = $value;

     return $value;

} // End of if statement.

// +--
// | Set requests have both a name and value passed
// | to this function.
// +--

if ((!(empty($name))) && (isset($value)) && (!(isset($default)))) {

     $xglobal_cache[$name] = $value;

     return $value;

} // End of if statement.

// +--
// | Get requests have only a global variable name
// | passed to this function.
// +--

if ((!(empty($name))) && (isset($xglobal_cache[$name]))) {

     return $xglobal_cache[$name];

} // End of if statement.

// +--
// | All other requests result in a null return value.
// +--

return null;

} // End of function.

// +------------------------------------------------------------------+
// | Function: paths_convert                                          |
// +------------------------------------------------------------------+

function paths_convert ($string) {

// +--
// | This function converts filesystem paths to unix-style and strips
// | any trailing slashes.
// +--

while (preg_match('/\\\\/',$string)) {$string = preg_replace('/\\\\/','/',$string);}

while (preg_match('/\/\//',$string)) {$string = preg_replace('/\/\//','/',$string);}

$string = preg_replace('/\/$/','',$string);

return $string;

} // End of function.

// +------------------------------------------------------------------+
// | Function: paths_strip                                            |
// +------------------------------------------------------------------+

function paths_strip ($string) {

// +--
// | This function strips full server paths from a given string for
// | security purposes.
// +--

$pathpub   = $this->globals('core.path_public');
$pathpriv  = $this->globals('core.path_private');
$pathforce = $this->globals('core.main_path_force');

$string = str_replace('\\','/',$string);

if (!(empty($pathforce))) {

     $find   = preg_quote($pathforce . '/','/');
     $string = preg_replace('/' . $find . '/','/',$string);

} // End of if statement.
 
if (!(empty($pathpub))) {

     $find   = preg_quote($pathpub . '/','/');
     $string = preg_replace('/' . $find . '/','/',$string);

} // End of if statement.

if (!(empty($pathpriv))) {

     $find   = preg_quote($pathpriv . '/','/');
     $string = preg_replace('/' . $find . '/','/',$string);

} // End of if statement.

return $string;

} // End of function.

// +------------------------------------------------------------------+
// | Function: error_display                                          |
// +------------------------------------------------------------------+

function error_display ($errno = '',$errstr = '',$errfile = '',$errline = '') {

// +--
// | This function is called via PHP when an error is encountered.
// | Scripts pass errors through this function via PHP's trigger_error
// | function using:
// |
// | trigger_error('some_error_message',E_USER_ERROR);
// | 
// | PHP also passes errors through this function without script
// | intervention.
// +--

// +--
// | If we've hit this function with a suppressed error or an E_STRICT
// | or E_NOTICE error, we return.
// +--

if ((error_reporting() == 0) || ($errno == E_NOTICE) || ($errno == E_STRICT)) {

     return 1;

} // End of if statement.

// +--
// | If we are currently buffering output, destroy the buffer
// | and reset buffer status.
// +--

if ($this->globals('installer.buffer_status')) {

     @ob_end_clean();

     $this->globals('installer.buffer_status',0);

} // End of if statement.

// +--
// | Modify our $errfile if it is non-blank.  We want to remove
// | full paths from error messages to increase security.
// +--

if ($errfile) {$errfile = $this->paths_strip($errfile);}

// +--
// | Modify our $errstr if it is non-blank.  We want to add <p>
// | tags if they're not there.
// +--

if (($errstr) && (!(preg_match('/<p>/',$errstr)))) {

     $errstr = '<p>' . $errstr . '</p>';

} // End of if statement.

// +--
// | Print output header.
// +--

print $this->error_div_header();

// +--
// | Print output content.
// +--

if ($errstr) {print $this->error_div_content($errstr);}

// +--
// | Print output info.
// +--

if ($errno && $errline && $errfile) {print $this->error_div_info($errno,$errline,$errfile);}

// +--
// | Print output footer.
// +--

print $this->error_div_footer();

// +--
// | This was a fatal error so we exit.
// +--

exit();

} // End of function.

// +------------------------------------------------------------------+
// | Function: error_div_header                                       |
// +------------------------------------------------------------------+

function error_div_header () {

// +--
// | This function prints the error header.
// +--

$xhtml = <<<ENDOFTEXT

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">

<html xmlns="http://www.w3.org/1999/xhtml">

<head>

<meta http-equiv="content-type" content="text/html; charset=ISO-8859-1" /> 

<style type="text/css" media="all">

body {
     font-family: Verdana, Tahoma, Arial, sans-serif;
     font-size: 12px;
     color: #333333;
     font-weight: normal;
     text-align: left;
     background-color: #F5F5F5;
     margin: 20px;
     }

a {
     color: #30569D;
     text-decoration: none;
     font-weight: normal;
     }

a:hover {
     text-decoration: underline;
     }

.strong {
     font-weight: bold;
     }

#content {
     color: #333333;
     background-color: #FFFFFF;
     border: 1px solid #333333;
     width: 600px;
     padding: 10px;
     margin: 0px auto 0px auto;
     -moz-border-radius: 8px 8px 0px 0px;
     -webkit-border-radius: 8px 8px 0px 0px;
     border-radius: 8px 8px 0px 0px;
     -moz-box-shadow: 2px 2px 2px #333333;
     -webkit-box-shadow: 2px 2px 2px #333333;
     box-shadow: 2px 2px 2px #333333;
     line-height: 1.5em;
     }

#info {
     color: #333333;
     background-color: #FFFFFF;
     border-left: 1px solid #333333;
     border-right: 1px solid #333333;
     border-bottom: 1px solid #333333;
     width: 600px;
     padding: 10px;
     margin: 0px auto 0px auto;
     -moz-border-radius: 0px 0px 8px 8px;
     -webkit-border-radius: 0px 0px 8px 8px;
     border-radius: 0px 0px 8px 8px;
     -moz-box-shadow: 2px 2px 2px #333333;
     -webkit-box-shadow: 2px 2px 2px #333333;
     box-shadow: 2px 2px 2px #333333;
     font-size: 11px;
     }

#pgtitle {
     color: #4E70AE;
     padding: 0px;
     margin: 0px 0px 10px 0px;
     font-weight: bold;
     font-size: 18px;
     }

</style>

<title>Script Execution Error</title>

</head>

<body>

ENDOFTEXT;

return $xhtml;

} // End of function.

// +------------------------------------------------------------------+
// | Function: error_div_content                                      |
// +------------------------------------------------------------------+

function error_div_content ($errstr = '') {

// +--
// | This function prints the error contet.
// +--

$xhtml = <<<ENDOFTEXT

<div id="content">

<div id="pgtitle">Script Execution Error</div>

{$errstr}

</div>

ENDOFTEXT;

return $xhtml;

} // End of function.

// +------------------------------------------------------------------+
// | Function: error_div_info                                         |
// +------------------------------------------------------------------+

function error_div_info ($errno = '',$errline = '',$errfile = '') {

// +--
// | This function prints the error info.
// +--

$xhtml = <<<ENDOFTEXT

<div id="info">File: {$errfile} Line: {$errline} Error Number: {$errno}</div>

ENDOFTEXT;

return $xhtml;

} // End of function.

// +------------------------------------------------------------------+
// | Function: error_div_footer                                       |
// +------------------------------------------------------------------+

function error_div_footer () {

// +--
// | This function prints the error footer.
// +--

$xhtml = <<<ENDOFTEXT

</body>

</html>

ENDOFTEXT;

return $xhtml;

} // End of function.

// +------------------------------------------------------------------+
// | End of Class                                                     |
// +------------------------------------------------------------------+

} // End of class.

// +------------------------------------------------------------------+
// |------------------------------------------------------------------|
// |------------------------------------------------------------------|
// |                                                                  |
// | Importer Core Class                                              |
// |                                                                  |
// |------------------------------------------------------------------|
// |------------------------------------------------------------------|
// +------------------------------------------------------------------+

// +------------------------------------------------------------------+
// | Class Definition: COREimporter                                   |
// +------------------------------------------------------------------+

class COREimporter {

// +--
// | This class handles data imports into the core  This script is to 
// | be considered standalone software and it's architecture and 
// | methodology are not indicative of the core core codebase.  
// | Do not use code in this COREimporter class as a basis for core
// | core or component code.
// +--

// +------------------------------------------------------------------+
// | Class Variables                                                  |
// +------------------------------------------------------------------+

var $class   = 'COREimporter';
var $version = '8.0.0';
var $cerror;

var $dbrows_atonce = 100;

var $CORE;
var $CORE_Display;
var $CORE_DB;
var $CORE_DBX;
var $CORE_Crypt;
var $CORE_File;
var $CORE_Remote;
var $CORE_XML;

// +------------------------------------------------------------------+
// | Constructor Function                                             |
// +------------------------------------------------------------------+

function COREimporter ($core_object = '') {

// +--
// | This is the constructor function.  This function starts up the
// | class.  Any pre-load variable assignments go here.
// +--

// +--
// | Define our CORE object.
// +--

$this->CORE =& $core_object;

// +--
// | Quick object load: CORE_Display
// +--

$this->CORE_Display =& $this->CORE->quick_object('CORE_Display','core');

if ($this->CORE->IsError($this->CORE_Display)) {$this->cerror = $this->CORE_Display; return;}

// +--
// | Quick object load: CORE_DB
// +--

$this->CORE_DB =& $this->CORE->quick_object('CORE_DB','core','CORE_DB_1');

if ($this->CORE->IsError($this->CORE_DB)) {$this->cerror = $this->CORE_DB; return;}

// +--
// | Quick object load: CORE_Crypt
// +--

$this->CORE_Crypt =& $this->CORE->quick_object('CORE_Crypt','core');

if ($this->CORE->IsError($this->CORE_Crypt)) {$this->cerror = $this->CORE_Crypt; return;}

// +--
// | Quick object load: CORE_File
// +--

$this->CORE_File =& $this->CORE->quick_object('CORE_File','core');

if ($this->CORE->IsError($this->CORE_File)) {$this->cerror = $this->CORE_File; return;}

// +--
// | Quick object load: CORE_Remote
// +--

$this->CORE_Remote =& $this->CORE->quick_object('CORE_Remote','core');

if ($this->CORE->IsError($this->CORE_Remote)) {$this->cerror = $this->CORE_Remote; return;}

// +--
// | Quick object load: CORE_XML
// +--

$this->CORE_XML =& $this->CORE->quick_object('CORE_XML','core');

if ($this->CORE->IsError($this->CORE_XML)) {$this->cerror = $this->CORE_XML; return;}

// +--
// | Load the PEAR File_Find class.
// +--

$result = $this->CORE->load_pear('File_Find');

if ($this->CORE->IsError($result)) {$this->cerror = $result; return;}

// +--
// | Return object.
// +--

return $this;

} // End of function.

// +------------------------------------------------------------------+
// |------------------------------------------------------------------|
// |------------------------------------------------------------------|
// |                                                                  |
// | Importer Wrapper                                                 |
// |                                                                  |
// |------------------------------------------------------------------|
// |------------------------------------------------------------------|
// +------------------------------------------------------------------+

// +------------------------------------------------------------------+
// | Function: exec                                                   |
// +------------------------------------------------------------------+

function exec () {

// +--
// | This function runs the internals of the importer program.
// +--

// +--
// | Define some important variables.
// +--

$this->CORE->globals('importer.numsteps','16');

// +--
// | Start buffering output.
// +--

if (!($this->CORE->globals('importer.buffer_status'))) {

     @ob_start();

     $this->CORE->globals('importer.buffer_status',1);

} // End of if statement.

// +--
// | Start processing.
// +--

$result = $this->exec_do();

if ($this->CORE->IsError($result)) {

     trigger_error($result->GetMessage(),E_USER_ERROR);

} // End of if statement.

// +--
// | Finish buffering output.
// +--

if ($this->CORE->globals('importer.buffer_status')) {

     $buffered_output = @ob_get_contents();

     @ob_end_clean();

     $this->CORE->globals('importer.buffered_output',$buffered_output);

     $this->CORE->globals('importer.buffer_status',0);

} // End of if statement.

// +--
// | Kill the buffering in the core and set our display status to
// | false.
// +--

$this->CORE_Display->buffer('CLEAN');

$this->CORE->globals('core.output',0);

// +--
// | Print the display.
// +--

$this->disp();

// +--
// | Return true.
// +--

return 1;

} // End of function.

// +------------------------------------------------------------------+
// | Function: exec_do                                                |
// +------------------------------------------------------------------+

function exec_do () {

// +--
// | This function processes the main logic of the importer.
// +--

// +--
// | Define the step we're on.
// +--

$step = $this->CORE->globals('core_cgi.step');

if (!($step)) {$step = 'Intro';}

// +--
// | Get password info from form input and present the right 
// | interface.
// +--

$password = $this->CORE->globals('core.password');

if (!(empty($password))) {

     $import_password = $this->CORE->globals('core_cgi.import_password');

     if (!($import_password)) {

          $step = 'Password';

     } elseif (md5($import_password) != $password) {

          $message = "The password you entered is incorrect.  Please try again.";
          $step    = 'Password';

          $this->disp_message($message,'ERROR');

     } // End of if statement.

} elseif ($step != 'IntroP') {

     $step = 'Intro';

} // End of if statement.

// +--
// | Check the status of our license agreement acceptance.
// +--

$license_agree = $this->CORE->globals('core_cgi.license_agree');

if (empty($license_agree)) {

          if ($step != 'Password' && $step != 'Intro') {

          $message = "You did not agree to the terms and conditions in the EULA.  
                      You must agree to these terms and conditions to continue.";

          if ($step == 'IntroP') {$step = 'Intro';}

          else {$step = 'Password';}

          $this->disp_message($message,'ERROR');

     } // End of if statement.

} // End of if statement.

// +--
// | Execute our step.
// +--

$result = $this->exec_step($step);

if ($this->CORE->IsError($result)) {return $result;}

// +--
// | Return true.
// +--

return 1;

} // End of function.

// +------------------------------------------------------------------+
// | Function: exec_step                                              |
// +------------------------------------------------------------------+

function exec_step ($step = 'Default') {

// +--
// | This function executes importer steps.
// +--

// +--
// | Use the step to figure out what we need to be doing.  If the
// | step is blank, we default to step I.  A list of the steps is
// | below:
// |
// | Step Number  Action          
// | -----------  -------------------
// | Default      Default Invalid Info Screen
// | Password     Password Collection
// | Location     Installation Location
// | LocationP    Installation Location - Process
// | Settings     Software Settings
// | SettingsP    Software Settings - Process
// | Media        Media Files
// | MediaP       Media Files - Process
// | CustAcct     Customer Accounts
// | CustAcctP    Customer Accounts - Processs
// | Affiliates   Affiliate Payments 
// | AffiliatesP  Affiliate Payments - Process
// | Maillist     Guest Maillist Subscribers
// | MaillistP    Guest Maillist Subscribers - Process
// | Category     Categories
// | CategoryP    Categories - Process
// | Product      Products
// | ProductP     Products - Process
// | ProdOpt      Product Options
// | ProdOptP     Product Options - Process
// | ProdOptSel   Product Option Selection Items
// | ProdOptSelP  Product Option Selection Items - Process
// | Orders       Orders
// | OrdersP      Orders - Process
// | OrderItems   OrderItems
// | OrderItemsP  OrderItems - Process
// | Discounts    Discount Codes
// | DiscountsP   Discount Codes - Process
// | HtmlPage     HTML Pages (User Defined)
// | HtmlPageP    HTML Pages (User Defined) - Process
// | DynForm      Dynamic Forms
// | DynFormP     Dynamic Forms - Process
// | DynFormFld   Dynamic Form Fields
// | DynFormFldP  Dynamic Form Fields - Process
// | Final        Final Confirm Display
// +--

switch ($step) {

     case "Password":
          $result = $this->step_Password();
          break;

     case "Location":
          $result = $this->step_Location();
          break;

     case "LocationP":
          $result = $this->step_LocationP();
          if ($this->CORE->IsError($result)) {
               $this->disp_message($result->GetMessage(),'ERROR');
               return $this->step_Location();
          }
          break;

     case "Settings":
          $result = $this->step_Settings();
          break;

     case "SettingsP":
          $result = $this->step_SettingsP();
          if ($this->CORE->IsError($result)) {
               $this->disp_message($result->GetMessage(),'ERROR');
               return $this->step_Settings();
          }
          break;

     case "Media":
          $result = $this->step_Media();
          break;

     case "MediaP":
          $result = $this->step_MediaP();
          if ($this->CORE->IsError($result)) {
               $this->disp_message($result->GetMessage(),'ERROR');
               return $this->step_Media();
          }
          break;

     case "CustAcct":
          $result = $this->step_CustAcct();
          break;

     case "CustAcctP":
          $result = $this->step_CustAcctP();
          if ($this->CORE->IsError($result)) {
               $this->disp_message($result->GetMessage(),'ERROR');
               return $this->step_CustAcct();
          }
          break;

     case "Affiliates":
          $result = $this->step_Affiliates();
          break;

     case "AffiliatesP":
          $result = $this->step_AffiliatesP();
          if ($this->CORE->IsError($result)) {
               $this->disp_message($result->GetMessage(),'ERROR');
               return $this->step_Affiliates();
          }
          break;

     case "Maillist":
          $result = $this->step_Maillist();
          break;

     case "MaillistP":
          $result = $this->step_MaillistP();
          if ($this->CORE->IsError($result)) {
               $this->disp_message($result->GetMessage(),'ERROR');
               return $this->step_Maillist();
          }
          break;

     case "Category":
          $result = $this->step_Category();
          break;

     case "CategoryP":
          $result = $this->step_CategoryP();
          if ($this->CORE->IsError($result)) {
               $this->disp_message($result->GetMessage(),'ERROR');
               return $this->step_Category();
          }
          break;

     case "Product":
          $result = $this->step_Product();
          break;

     case "ProductP":
          $result = $this->step_ProductP();
          if ($this->CORE->IsError($result)) {
               $this->disp_message($result->GetMessage(),'ERROR');
               return $this->step_Product();
          }
          break;

     case "ProdOpt":
          $result = $this->step_ProdOpt();
          break;

     case "ProdOptP":
          $result = $this->step_ProdOptP();
          if ($this->CORE->IsError($result)) {
               $this->disp_message($result->GetMessage(),'ERROR');
               return $this->step_ProdOpt();
          }
          break;

     case "ProdOptSel":
          $result = $this->step_ProdOptSel();
          break;

     case "ProdOptSelP":
          $result = $this->step_ProdOptSelP();
          if ($this->CORE->IsError($result)) {
               $this->disp_message($result->GetMessage(),'ERROR');
               return $this->step_ProdOptSel();
          }
          break;

     case "Orders":
          $result = $this->step_Orders();
          break;

     case "OrdersP":
          $result = $this->step_OrdersP();
          if ($this->CORE->IsError($result)) {
               $this->disp_message($result->GetMessage(),'ERROR');
               return $this->step_Orders();
          }
          break;

     case "OrderItems":
          $result = $this->step_OrderItems();
          break;

     case "OrderItemsP":
          $result = $this->step_OrderItemsP();
          if ($this->CORE->IsError($result)) {
               $this->disp_message($result->GetMessage(),'ERROR');
               return $this->step_OrderItems();
          }
          break;

     case "Discounts":
          $result = $this->step_Discounts();
          break;

     case "DiscountsP":
          $result = $this->step_DiscountsP();
          if ($this->CORE->IsError($result)) {
               $this->disp_message($result->GetMessage(),'ERROR');
               return $this->step_Discounts();
          }
          break;

     case "HtmlPage":
          $result = $this->step_HtmlPage();
          break;

     case "HtmlPageP":
          $result = $this->step_HtmlPageP();
          if ($this->CORE->IsError($result)) {
               $this->disp_message($result->GetMessage(),'ERROR');
               return $this->step_HtmlPage();
          }
          break;

     case "DynForm":
          $result = $this->step_DynForm();
          break;

     case "DynFormP":
          $result = $this->step_DynFormP();
          if ($this->CORE->IsError($result)) {
               $this->disp_message($result->GetMessage(),'ERROR');
               return $this->step_DynForm();
          }
          break;

     case "DynFormFld":
          $result = $this->step_DynFormFld();
          break;

     case "DynFormFldP":
          $result = $this->step_DynFormFldP();
          if ($this->CORE->IsError($result)) {
               $this->disp_message($result->GetMessage(),'ERROR');
               return $this->step_DynFormFld();
          }
          break;

     case "Final":
          $result = $this->step_Final();
          break;

     default:
          $result = $this->step_Default();
          break;

} // End of switch statement.

// +--
// | Return the result.
// +--

return $result;

} // End of function.

// +------------------------------------------------------------------+
// |------------------------------------------------------------------|
// |------------------------------------------------------------------|
// |                                                                  |
// | Importer Steps                                                   |
// |                                                                  |
// |------------------------------------------------------------------|
// |------------------------------------------------------------------|
// +------------------------------------------------------------------+

// +------------------------------------------------------------------+
// | Function: step_Default                                           |
// +------------------------------------------------------------------+

function step_Default () {

// +--
// | Importer Function Step.
// +--

// +--
// | Default Invalid Info Screen
// | 
// | This function prints a page indicating the importer was hit 
// | with invalid information and prints a valid importer link.
// +--

$insname = $this->CORE->globals('importer.script_name');

print <<<ENDOFTEXT

<p>You have accessed this importer script using invalid data.  In 
order to use the importer script, please follow the link below:</p>

<p><a href="{$insname}" title="importer">Click here to run the importer script.</a></p>

ENDOFTEXT;

// +--
// | Return true
// +--

return 1;

} // End of function.

// +------------------------------------------------------------------+
// | Function: step_Password                                          |
// +------------------------------------------------------------------+

function step_Password () {

// +--
// | Importer Function Step.
// +--

// +--
// | Password Collection
// | 
// | This function prints a form to be completed by the user to 
// | submit a password for this importer script.  This screen is 
// | accessed when a password already exists for the importer.
// +--

$software = $this->CORE->globals('importer.name');

print <<<ENDOFTEXT

<p>This data importer script is designed to import data from a {$software} 
installation into the primary database connection which this 
script is currenly associated with.</p>

<p><strong>Items that are imported by this script</strong>: 
Settings, media files, customer, affiliate and wholesale accounts, affiliate payments, 
mail list guest subscribers, categories, products, product options, dynamic forms, 
orders, discount codes and HTML pages (user defined).</p>

<p><strong>Items that are not imported by this script</strong>:  
Online processing settings, realtime shipping configuration information, 
custom shipping scripts, checkout form modifications, custom sale scripts, 
general display changes made to system includes, and skins.</p>

<p><strong>Please Note</strong>: If you have configured a database connection 
within your {$software} installation, that data source will be used for any 
tables you have exported to the database.  The access information needed to 
connect to that RDBMS will be automatically pulled from your {$software} 
installation.  There is no need to enter that information into this importer 
script.</p>

ENDOFTEXT;

// +--
// | Define the form.
// +--

$header = <<<ENDOFTEXT

<p>This importer script is protected by a password that was set up
during the initial installation of this program.  Enter the password 
you selected to protect the installer script below then click the 
'Continue' button at the bottom of this page to import data using this 
importer script.</p>

ENDOFTEXT;

$fields[0]['id']       = 'import_password';
$fields[0]['name']     = 'Installer Password';
$fields[0]['type']     = 'PASSWORD';
$fields[0]['required'] = '1';

$fields[0]['desc']     = <<<ENDOFTEXT

<p>Enter the password below that you selected to permit controlled 
access to the software installer.  If you do not remember the installer password 
you selected during the initial installation of this program, edit the 
'config.php' file in this directory.  Delete the MD5 hash assigned to the 
'core.password' variable to create a new password.</p>

ENDOFTEXT;

$fields[1]['id']       = 'license_agree';
$fields[1]['name']     = 'License Agreement';
$fields[1]['type']     = 'CHECKBOX';
$fields[1]['required'] = '1';
$fields[1]['values']   = array('1' => 'I agree to the terms and conditions in the EULA.');

$fields[1]['desc']     = <<<ENDOFTEXT

<p>Installation and use of this program requires you read and accept the 
End User License Agreement (EULA) distributed with this software.  Follow 
the link below to review the EULA.  The EULA is distributed in Adobe PDF 
format.  You will need Acrobat Reader, which is freely available from Adobe, 
to review the EULA.</p>

<p><a href="license.pdf" rel="external" title="License">Click here to review the EULA.</a></p>

ENDOFTEXT;

// +--
// | Print the form.
// +--

$this->disp_form(array('header' => $header,
                       'fields' => $fields,
                       'step'   => 'Location'));

// +--
// | Return true
// +--

return 1;

} // End of function.

// +------------------------------------------------------------------+
// | Function: step_Location                                          |
// +------------------------------------------------------------------+

function step_Location () {

// +--
// | Importer Function Step: 
// |
// | Installation Location
// +--

$this->CORE->globals('importer.step','1');
$this->CORE->globals('importer.steptext','Installation Location');

// +--
// | Print the form.
// +--

$software = $this->CORE->globals('importer.name');

$header = <<<ENDOFTEXT

<p>Indicate below the full server path to the public config.php file 
for your {$software} installation.</p>

ENDOFTEXT;

$fields[0]['id']       = 'import_pubconfig';
$fields[0]['name']     = 'Directory Path for Public Configuration File';
$fields[0]['type']     = 'TEXT-LONG';
$fields[0]['required'] = '1';

$fields[0]['desc']     = <<<ENDOFTEXT

<p>Enter the absolute directory path to the public config.php file used by your 
{$software} installation.</p>

<p>Example: /home/username/khxc/config.php or C:/Inetpub/khxc/config.php</p>

ENDOFTEXT;

// +--
// | Print the form.
// +--

$this->disp_form(array('header' => $header,
                       'fields' => $fields,
                       'step'   => 'LocationP'));

// +--
// | Return true
// +--

return 1;

} // End of function.

// +------------------------------------------------------------------+
// | Function: step_LocationP                                         |
// +------------------------------------------------------------------+

function step_LocationP () {

// +--
// | Importer Function Step: 
// |
// | Installation Location - Process
// +--

// +--
// | Make sure required fields were completed.
// +--

$fd = $this->formdata_array(array('import_pubconfig' => 1));

if ($this->CORE->IsError($fd)) {return $fd;}

// +--
// | Strip off any trailing slashes and convert to Unix style
// | paths/filenames.
// +--

$import_pubconfig = $this->CORE->paths_convert($fd['import_pubconfig']);

$this->CORE->globals('core_cgi.import_pubconfig',$import_pubconfig);

// +--
// | Check the formdata submission items and append error messages as
// | we go.
// +--

$errorcount = 0;

$errmsg     = "The following errors were encountered while attempting 
               to process your request: ";

// +--
// | Check the file.
// +--

if (!(@file_exists($import_pubconfig))) {

     $errorcount++;

     $errmsg .= " {$errorcount}. The directory path for the public config.php used by your
                 software installation is incorrect.  The path specified does not exist.";

} // End of if statement.

// +--
// | Make sure it's valid.
// +--

$result = $this->import_load_configphp($import_pubconfig);

if (empty($result)) {

     $errorcount++;

     $errmsg .= " {$errorcount}. The directory path for the public config.php used by your
                 software installation is incorrect.  The file referenced is invalid.";

} // End of if statement.

// +--
// | Make sure software is installed.
// +--

$result = $this->CORE->globals('importer.import_install_db');

if (empty($result)) {

     $errorcount++;

     $errmsg .= " {$errorcount}. The directory path for the public config.php used by your
                 software installation is incorrect.  The file referenced points to an 
                 incomplete installation.";

} // End of if statement.

// +--
// | Attempt to connect to the database.
// +--

$result = $this->import_connect_db();

if (empty($result)) {

     $errorcount++;

     $errmsg .= " {$errorcount}. The directory path for the public config.php used by your
                 software installation is incorrect.  The file referenced refers to invalid 
                 database connection information.";

} // End of if statement.

// +--
// | Return errors if we have any at this point.
// +--

if ($errorcount) {

     $result = $this->CORE->RaiseError($errmsg);

     return $result;

} // End of if statement.

// +--
// | Print a confirmation message.
// +--

$message = "Thank you. The path to your public config.php file has been  
            validated.  You can now continue through the import process.";

$this->disp_message($message,'CONFIRM');

// +--
// | Go to the next step.
// +--

return $this->step_Settings();

} // End of function.

// +------------------------------------------------------------------+
// | Function: step_Settings                                          |
// +------------------------------------------------------------------+

function step_Settings () {

// +--
// | Importer Function Step: 
// |
// | Software Settings Import
// +--

$this->CORE->globals('importer.step','2');
$this->CORE->globals('importer.steptext','Software Settings Import');

// +--
// | Print the form.
// +--

$this->CORE->globals('core_cgi.import_do','0');

$software = $this->CORE->globals('importer.name');

$header = <<<ENDOFTEXT

<p>Indicate below whether you would like to import settings from your {$software} 
installation.</p>

ENDOFTEXT;

$fields[0]['id']       = 'import_do';
$fields[0]['name']     = 'Software Settings Import';
$fields[0]['type']     = 'RADIO';
$fields[0]['required'] = '1';
$fields[0]['values']   = array('0' => 'Skip this step.',
                               '1' => 'Import settings from ' . $software . '.');

$fields[0]['desc']     = <<<ENDOFTEXT

<p>Indcate whether you would like to import the settings from your {$software} 
installation.  You have the option to skip this step.</p>

ENDOFTEXT;

// +--
// | Print the form.
// +--

$this->disp_form(array('header' => $header,
                       'fields' => $fields,
                       'step'   => 'SettingsP'));

// +--
// | Return true
// +--

return 1;

} // End of function.

// +------------------------------------------------------------------+
// | Function: step_SettingsP                                         |
// +------------------------------------------------------------------+

function step_SettingsP () {

// +--
// | Importer Function Step: 
// |
// | Software Settings Import - Process
// +--

// +--
// | Make sure required fields were completed.
// +--

$fd = $this->formdata_array(array('import_pubconfig'    => 1,
                                  'import_do'          => 0));

if ($this->CORE->IsError($fd)) {return $fd;}

// +--
// | Go to the next step and print a confirm message if we're skipping
// | this step.
// +--

if (empty($fd['import_do'])) {

     $message = "Thank you. You selected to skip importing settings.  No 
                 settings have been imported.  You can now continue through 
                 the import process.";

     $this->disp_message($message,'CONFIRM');

     return $this->step_Media();

} // End of if statement.

// +--
// | Connect to the database and define what we've got.
// +--

$this->import_load_configphp($fd['import_pubconfig']);

$this->import_connect_db();

$this->import_define_db();

$import_settings = $this->CORE->globals('importer.import_db_settings');
$import_ecomapp  = $this->CORE->globals('importer.import_db_ecomapp');

// +--
// | Convert a few settings.
// +--

$convert = array($import_ecomapp . '.xmodsitemap_se' => 'khxc.xmodsitemap_se',
                 $import_ecomapp . '.xmodsitemap_showcatsprods' => 'khxc.xmodsitemap_showcatsprods',
                 $import_ecomapp . '.xmodsitemap_showhtml' => 'khxc.xmodsitemap_showhtml',
                 $import_ecomapp . '.xmodsitemap_status' => 'khxc.xmodsitemap_status',
                 $import_ecomapp . '.metadesc' => 'khxc.metadesc',
                 $import_ecomapp . '.metakeywords' => 'khxc.metakeywords',
                 $import_ecomapp . '.metatitle' => 'khxc.metatitle',
                 $import_ecomapp . '.site_name' => 'khxc.site_name',
                 $import_ecomapp . '.siteowneradd' => 'khxc.siteowneradd',
                 $import_ecomapp . '.siteownercity' => 'khxc.siteownercity',
                 $import_ecomapp . '.siteownercountry' => 'khxc.siteownercountry',
                 $import_ecomapp . '.siteownerfax' => 'khxc.siteownerfax',
                 $import_ecomapp . '.siteownerphone' => 'khxc.siteownerphone',
                 $import_ecomapp . '.siteownerstateprov' => 'khxc.siteownerstateprov',
                 $import_ecomapp . '.siteownerzip' => 'khxc.siteownerzip');

foreach ($convert as $old => $new) {

     if (isset($import_settings[$old])) {$import_settings[$new] = $import_settings[$old]; unset($import_settings[$old]);}

} // End of foreach statement.

// +--
// | Handle importing the settings.
// +--

$sql  = "SELECT id,displaytype FROM core_settings";

$result= $this->CORE_DB->sql_do(array('sql'   => $sql,
                                      'table' => 'core_settings',
                                      'order' => array('id' => 'ASC')));

if (($this->CORE->IsError($result)) || (empty($result))) {$result = array();}

$this_settings = array();

if (!(empty($result))) {foreach ($result as $num => $data) {$this_settings[$data['id']] = $data['displaytype'];}}

$import_cryptkey = $this->CORE->globals('importer.import_cryptkey');

if ((!(empty($this_settings))) && (!(empty($import_settings)))) {

     foreach ($this_settings as $tid => $tdisplaytype) {

          $iid = $tid;
          $iid = preg_replace('/^core\./','khxc.',$iid);
          $iid = preg_replace('/^ecom\./',$import_ecomapp . '.',$iid);

          if (isset($import_settings[$iid])) {

               if (($tdisplaytype == 'TEXTBOX-CRYPT') && ($import_cryptkey)) {

                    $import_settings[$iid] = $this->CORE_Crypt->decrypt($import_settings[$iid],$import_cryptkey);

                    $import_settings[$iid] = $this->CORE_Crypt->encrypt($import_settings[$iid]);                

               } // End of if statement.

               $data = array('value' => $import_settings[$iid]);

               $update_clause = $this->CORE_DB->clause_update(array('table'      => 'core_settings',
                                                                    'data'       => $data));

              if (!($this->CORE->IsError($update_clause))) {

                   $sql = $update_clause . " WHERE id=" . $this->CORE_DB->quote($tid);

                   $result = $this->CORE_DB->sql_do(array('sql'   => $sql,
                                                          'table' => 'core_settings'));

               } // End of if statement.


          } // End of if statement.

     } // End of foreach statement.

} // End of if statement.

// +--
// | Print a confirmation message.
// +--

$message = "Thank you. Settings have been imported.  You can now continue 
            through the import process.";

$this->disp_message($message,'CONFIRM');

// +--
// | Go to the next step.
// +--

return $this->step_Media();

} // End of function.

// +------------------------------------------------------------------+
// | Function: step_Media                                             |
// +------------------------------------------------------------------+

function step_Media () {

// +--
// | Importer Function Step: 
// |
// | Media File Import
// +--

$this->CORE->globals('importer.step','3');
$this->CORE->globals('importer.steptext','Media File Import');

// +--
// | Print the form.
// +--

$this->CORE->globals('core_cgi.import_do','0');

$software = $this->CORE->globals('importer.name');

$header = <<<ENDOFTEXT

<p>Indicate below whether you would like to import media files from your {$software} 
installation.</p>

ENDOFTEXT;

$fields[0]['id']       = 'import_do';
$fields[0]['name']     = 'Media File Import';
$fields[0]['type']     = 'RADIO';
$fields[0]['required'] = '1';
$fields[0]['values']   = array('0' => 'Skip this step.',
                               '1' => 'Import media files from ' . $software . '.');

$fields[0]['desc']     = <<<ENDOFTEXT

<p>Indcate whether you would like to import the media files from your {$software} 
installation.  You have the option to skip this step.</p>

ENDOFTEXT;

// +--
// | Print the form.
// +--

$this->disp_form(array('header' => $header,
                       'fields' => $fields,
                       'step'   => 'MediaP'));

// +--
// | Return true
// +--

return 1;

} // End of function.

// +------------------------------------------------------------------+
// | Function: step_MediaP                                            |
// +------------------------------------------------------------------+

function step_MediaP () {

// +--
// | Importer Function Step: 
// |
// | Media File Import - Process
// +--

// +--
// | Make sure required fields were completed.
// +--

$fd = $this->formdata_array(array('import_pubconfig'    => 1,
                                  'import_do'          => 0));

if ($this->CORE->IsError($fd)) {return $fd;}

// +--
// | Go to the next step and print a confirm message if we're skipping
// | this step.
// +--

if (empty($fd['import_do'])) {

     $message = "Thank you. You selected to skip importing media files.  No 
                 files have been imported.  You can now continue through 
                 the import process.";

     $this->disp_message($message,'CONFIRM');

     return $this->step_CustAcct();

} // End of if statement.

// +--
// | Connect to the database and define what we've got.
// +--

$this->import_load_configphp($fd['import_pubconfig']);

$this->import_connect_db();

$this->import_define_db();

$import_settings = $this->CORE->globals('importer.import_db_settings');
$import_ecomapp  = $this->CORE->globals('importer.import_db_ecomapp');

// +--
// | Handle importing the data.
// +--

$dirdlsrc    = $this->CORE->globals('importer.import_path_private')  . '/downloads';
$dirmedia    = $this->CORE->globals('importer.import_path_public') . '/media';
$destdlsrc   = $this->CORE->globals('core.path_private') . '/downloads';
$destmedia   = $this->CORE->globals('core.path_public') . '/media';

$translation = array($dirdlsrc                                      => $destdlsrc,
                     $dirmedia . '/' . $import_ecomapp . '/cat'     => $destmedia . '/ecom/cat',
                     $dirmedia . '/' . $import_ecomapp . '/prodsm'  => $destmedia . '/ecom/prodsm',
                     $dirmedia . '/' . $import_ecomapp . '/prodlg'  => $destmedia . '/ecom/prodlg',
                     $dirmedia . '/' . $import_ecomapp . '/prodxl'  => $destmedia . '/ecom/prodxl',
                     $dirmedia . '/' . $import_ecomapp . '/html'    => $destmedia . '/cms/html');

$this->CORE_File->make_dir($destmedia . '/cms/html');

foreach ($translation as $source => $dest) {

     $files  = array();

     $handle = @opendir($source);

     if (!(empty($handle))) {

          while (false !== ($file = @readdir($handle))) {

               if (($file != 'dir.txt') && ($file != 'index.htm') && ($file != 'default.htm') && (is_file($source . '/' . $file))) {

                    if (!(file_exists($dest . '/' . $file))) {

                         $this->CORE_File->copy(array('source' => $source . '/' . $file,
                                                      'dest'   => $dest . '/' . $file));

                    } // End of if statement.

               } // End of if statement.

          } // End of while statement.

     } // End of if statement.

} // End of foreach statement.

// +--
// | Print a confirmation message.
// +--

$message = "Thank you. Media files have been imported.  You can now continue 
            through the import process.";

$this->disp_message($message,'CONFIRM');

// +--
// | Go to the next step.
// +--

return $this->step_CustAcct();

} // End of function.

// +------------------------------------------------------------------+
// | Function: step_CustAcct                                          |
// +------------------------------------------------------------------+

function step_CustAcct () {

// +--
// | Importer Function Step: 
// |
// | Customer Account Import
// +--

$this->CORE->globals('importer.step','4');
$this->CORE->globals('importer.steptext','Customer Account Import');

// +--
// | Print the form.
// +--

$this->CORE->globals('core_cgi.import_do','0');

$software = $this->CORE->globals('importer.name');

$header = <<<ENDOFTEXT

<p>Indicate below whether you would like to import customer accounts from your {$software} 
installation.</p>

ENDOFTEXT;

$fields[0]['id']       = 'import_do';
$fields[0]['name']     = 'Customer Account Import';
$fields[0]['type']     = 'RADIO';
$fields[0]['required'] = '1';
$fields[0]['values']   = array('0' => 'Skip this step.',
                               '1' => 'Import customer accounts from ' . $software . '.');

$fields[0]['desc']     = <<<ENDOFTEXT

<p>Indcate whether you would like to import the customer accounts from your {$software} 
installation.  You have the option to skip this step.</p>

ENDOFTEXT;

// +--
// | Print the form.
// +--

$this->disp_form(array('header' => $header,
                       'fields' => $fields,
                       'step'   => 'CustAcctP'));

// +--
// | Return true
// +--

return 1;

} // End of function.

// +------------------------------------------------------------------+
// | Function: step_CustAcctP                                         |
// +------------------------------------------------------------------+

function step_CustAcctP () {

// +--
// | Importer Function Step: 
// |
// | Customer Account Import - Process
// +--

// +--
// | Make sure required fields were completed.
// +--

$fd = $this->formdata_array(array('import_pubconfig'   => 1,
                                  'import_do'          => 0));

if ($this->CORE->IsError($fd)) {return $fd;}

// +--
// | Go to the next step and print a confirm message if we're skipping
// | this step.
// +--

if (empty($fd['import_do'])) {

     $message = "Thank you. You selected to skip importing customer accounts.  No 
                 accounts have been imported.  You can now continue through 
                 the import process.";

     $this->disp_message($message,'CONFIRM');

     return $this->step_Affiliates();

} // End of if statement.

// +--
// | Connect to the database and define what we've got.
// +--

$this->import_load_configphp($fd['import_pubconfig']);

$this->import_connect_db();

$this->import_define_db();

$import_settings = $this->CORE->globals('importer.import_db_settings');
$import_ecomapp  = $this->CORE->globals('importer.import_db_ecomapp');

// +--
// | Handle multi-step operations.
// +--

$offset      = $this->CORE->globals('core_cgi.offset'); if (empty($offset)) {$offset = 0;}
$count       = $this->dbrows_atonce;
$rowcount    = $this->import_count_rows('khxc_users');
$endnum_calc = $offset + $this->dbrows_atonce;

if ($rowcount <= $endnum_calc) {$completed = 1;} else {$completed = 0;}

$new_offset  = $offset + $this->dbrows_atonce;
$ntaskcount  = ceil($rowcount / $this->dbrows_atonce);

if ($offset == 0)     {$ntaskcurr = 1;
} elseif ($completed) {$ntaskcurr = $ntaskcount;
} else                {$ntaskcurr = ceil($new_offset / $this->dbrows_atonce);}

$mtinfo = array();

$mtinfo['currstep']   = 'CustAcctP';
$mtinfo['currtask']   = 'Customer Account Import';

$mtinfo['offset']     = $new_offset;
$mtinfo['ntaskcount'] = $ntaskcount;
$mtinfo['ntaskcurr']  = $ntaskcurr;
$mtinfo['mtcomplete'] = $completed;

$cgimtcomplete = $this->CORE->globals('core_cgi.mtcomplete');

// +--
// | Load data.
// +--

$data = $this->import_load_data('khxc_users',$offset,$count);

if ((!(empty($data))) && ($rowcount > 0) && (empty($cgimtcomplete))) {

     foreach ($data as $num => $row) {

          // +--
          // | SPECIAL: Username field - autocalculated.
          // +--

          $row['username'] = $this->CORE->random_number(10);

          // +--
          // | Do the insert and don't worry about errors.  By doing an insert
          // | we don't overwrite any existing data.
          // +--

          $sql = $this->CORE_DB->clause_insert(array('table' => 'core_users',
                                                     'data'  => $row));

          if (!($this->CORE->IsError($sql))) {

               $this->CORE_DB->sql_do(array('sql'   => $sql,
                                            'table' => 'core_users'));

          } // End of if statement.


     } // End of foreach statement.

     // +--
     // | Present the multitask form.
     // +--

     return $this->do_multitask($mtinfo);

// +--
// | We're finished otherwise.
// +--

} else {

     $message = "Thank you. Customer accounts have been imported.  You can now continue 
                 through the import process.";

     $this->disp_message($message,'CONFIRM');

     return $this->step_Affiliates();

} // End of if statement.

} // End of function.

// +------------------------------------------------------------------+
// | Function: step_Affiliates                                        |
// +------------------------------------------------------------------+

function step_Affiliates () {

// +--
// | Importer Function Step: 
// |
// | Affiliate Payments Import
// +--

$this->CORE->globals('importer.step','5');
$this->CORE->globals('importer.steptext','Affiliate Payments Import');

// +--
// | Print the form.
// +--

$this->CORE->globals('core_cgi.import_do','0');

$software = $this->CORE->globals('importer.name');

$header = <<<ENDOFTEXT

<p>Indicate below whether you would like to import affiliate payments from your {$software} 
installation.</p>

ENDOFTEXT;

$fields[0]['id']       = 'import_do';
$fields[0]['name']     = 'Affiliate Payments Import';
$fields[0]['type']     = 'RADIO';
$fields[0]['required'] = '1';
$fields[0]['values']   = array('0' => 'Skip this step.',
                               '1' => 'Import affiliate payments from ' . $software . '.');

$fields[0]['desc']     = <<<ENDOFTEXT

<p>Indcate whether you would like to import the affiliate payments from your {$software} 
installation.  You have the option to skip this step.</p>

ENDOFTEXT;

// +--
// | Print the form.
// +--

$this->disp_form(array('header' => $header,
                       'fields' => $fields,
                       'step'   => 'AffiliatesP'));

// +--
// | Return true
// +--

return 1;

} // End of function.

// +------------------------------------------------------------------+
// | Function: step_AffiliatesP                                       |
// +------------------------------------------------------------------+

function step_AffiliatesP () {

// +--
// | Importer Function Step: 
// |
// | Affiliate Payments Import - Process
// +--

// +--
// | Make sure required fields were completed.
// +--

$fd = $this->formdata_array(array('import_pubconfig'   => 1,
                                  'import_do'          => 0));

if ($this->CORE->IsError($fd)) {return $fd;}

// +--
// | Go to the next step and print a confirm message if we're skipping
// | this step.
// +--

if (empty($fd['import_do'])) {

     $message = "Thank you. You selected to skip importing affiliate payments. 
                 No payments have been imported.  You can now continue through 
                 the import process.";

     $this->disp_message($message,'CONFIRM');

     return $this->step_MailList();

} // End of if statement.

// +--
// | Connect to the database and define what we've got.
// +--

$this->import_load_configphp($fd['import_pubconfig']);

$this->import_connect_db();

$this->import_define_db();

$import_settings = $this->CORE->globals('importer.import_db_settings');
$import_ecomapp  = $this->CORE->globals('importer.import_db_ecomapp');

// +--
// | Handle multi-step operations.
// +--

$offset      = $this->CORE->globals('core_cgi.offset'); if (empty($offset)) {$offset = 0;}
$count       = $this->dbrows_atonce;
$rowcount    = $this->import_count_rows('khxc_affpay');
$endnum_calc = $offset + $this->dbrows_atonce;

if ($rowcount <= $endnum_calc) {$completed = 1;} else {$completed = 0;}

$new_offset  = $offset + $this->dbrows_atonce;
$ntaskcount  = ceil($rowcount / $this->dbrows_atonce);

if ($offset == 0)     {$ntaskcurr = 1;
} elseif ($completed) {$ntaskcurr = $ntaskcount;
} else                {$ntaskcurr = ceil($new_offset / $this->dbrows_atonce);}

$mtinfo = array();

$mtinfo['currstep']   = 'AffiliatesP';
$mtinfo['currtask']   = 'Affiliate Payments Import';

$mtinfo['offset']     = $new_offset;
$mtinfo['ntaskcount'] = $ntaskcount;
$mtinfo['ntaskcurr']  = $ntaskcurr;
$mtinfo['mtcomplete'] = $completed;

$cgimtcomplete = $this->CORE->globals('core_cgi.mtcomplete');

// +--
// | Load data.
// +--

$data = $this->import_load_data('khxc_affpay',$offset,$count);

if ((!(empty($data))) && ($rowcount > 0) && (empty($cgimtcomplete))) {

     foreach ($data as $num => $row) {

          // +--
          // | Do the insert and don't worry about errors.  By doing an insert
          // | we don't overwrite any existing data.
          // +--

          $sql = $this->CORE_DB->clause_insert(array('table' => 'core_affpay',
                                                     'data'  => $row));

          if (!($this->CORE->IsError($sql))) {

               $this->CORE_DB->sql_do(array('sql'   => $sql,
                                            'table' => 'core_affpay'));

          } // End of if statement.


     } // End of foreach statement.

     // +--
     // | Present the multitask form.
     // +--

     return $this->do_multitask($mtinfo);

// +--
// | We're finished otherwise.
// +--

} else {

     $message = "Thank you. Affiliate payments have been imported.  You can now continue 
                 through the import process.";

     $this->disp_message($message,'CONFIRM');

     return $this->step_MailList();

} // End of if statement.

} // End of function.

// +------------------------------------------------------------------+
// | Function: step_Maillist                                          |
// +------------------------------------------------------------------+

function step_Maillist () {

// +--
// | Importer Function Step: 
// |
// | Mail List Import
// +--

$this->CORE->globals('importer.step','6');
$this->CORE->globals('importer.steptext','Mail List Guest Subscriber Import');

// +--
// | Print the form.
// +--

$this->CORE->globals('core_cgi.import_do','0');

$software = $this->CORE->globals('importer.name');

$header = <<<ENDOFTEXT

<p>Indicate below whether you would like to import mail list guest subscribers from 
your {$software} installation.  If you choose to import mail list guest subscribers, 
customer accounts will be created for them and random passwords will be assigned 
to each account created.</p>

ENDOFTEXT;

$fields[0]['id']       = 'import_do';
$fields[0]['name']     = 'Mail List Guest Subscriber Import';
$fields[0]['type']     = 'RADIO';
$fields[0]['required'] = '1';
$fields[0]['values']   = array('0' => 'Skip this step.',
                               '1' => 'Import mail list guest subscribers from ' . $software . '.');

$fields[0]['desc']     = <<<ENDOFTEXT

<p>Indcate whether you would like to import the mail list guest subscribers from your {$software} 
installation.  You have the option to skip this step.</p>

ENDOFTEXT;

// +--
// | Print the form.
// +--

$this->disp_form(array('header' => $header,
                       'fields' => $fields,
                       'step'   => 'MaillistP'));

// +--
// | Return true
// +--

return 1;

} // End of function.

// +------------------------------------------------------------------+
// | Function: step_MaillistP                                         |
// +------------------------------------------------------------------+

function step_MaillistP () {

// +--
// | Importer Function Step: 
// |
// | Mail List Import - Process
// +--

// +--
// | Make sure required fields were completed.
// +--

$fd = $this->formdata_array(array('import_pubconfig'   => 1,
                                  'import_do'          => 0));

if ($this->CORE->IsError($fd)) {return $fd;}

// +--
// | Go to the next step and print a confirm message if we're skipping
// | this step.
// +--

if (empty($fd['import_do'])) {

     $message = "Thank you. You selected to skip importing mail list guest subscribers. 
                 No subscribers have been imported.  You can now continue through 
                 the import process.";

     $this->disp_message($message,'CONFIRM');

     return $this->step_Category();

} // End of if statement.

// +--
// | Connect to the database and define what we've got.
// +--

$this->import_load_configphp($fd['import_pubconfig']);

$this->import_connect_db();

$this->import_define_db();

$import_settings = $this->CORE->globals('importer.import_db_settings');
$import_ecomapp  = $this->CORE->globals('importer.import_db_ecomapp');

// +--
// | Handle multi-step operations.
// +--

$offset      = $this->CORE->globals('core_cgi.offset'); if (empty($offset)) {$offset = 0;}
$count       = $this->dbrows_atonce;
$rowcount    = $this->import_count_rows('khxc_guestsub');
$endnum_calc = $offset + $this->dbrows_atonce;

if ($rowcount <= $endnum_calc) {$completed = 1;} else {$completed = 0;}

$new_offset  = $offset + $this->dbrows_atonce;
$ntaskcount  = ceil($rowcount / $this->dbrows_atonce);

if ($offset == 0)     {$ntaskcurr = 1;
} elseif ($completed) {$ntaskcurr = $ntaskcount;
} else                {$ntaskcurr = ceil($new_offset / $this->dbrows_atonce);}

$mtinfo = array();

$mtinfo['currstep']   = 'MaillistP';
$mtinfo['currtask']   = 'Mail List Guest Subscriber Import';

$mtinfo['offset']     = $new_offset;
$mtinfo['ntaskcount'] = $ntaskcount;
$mtinfo['ntaskcurr']  = $ntaskcurr;
$mtinfo['mtcomplete'] = $completed;

$cgimtcomplete = $this->CORE->globals('core_cgi.mtcomplete');

// +--
// | Load data.
// +--

$data = $this->import_load_data('khxc_guestsub',$offset,$count);

if ((!(empty($data))) && ($rowcount > 0) && (empty($cgimtcomplete))) {

     foreach ($data as $num => $row) {

          // +--
          // | Do the insert and don't worry about errors.  By doing an insert
          // | we don't overwrite any existing data.
          // +--

          $sql = $this->CORE_DB->clause_insert(array('table' => 'core_guestsub',
                                                     'data'  => $row));

          if (!($this->CORE->IsError($sql))) {

               $this->CORE_DB->sql_do(array('sql'   => $sql,
                                            'table' => 'core_guestsub'));

          } // End of if statement.

     } // End of foreach statement.

     // +--
     // | Present the multitask form.
     // +--

     return $this->do_multitask($mtinfo);

// +--
// | We're finished otherwise.
// +--

} else {

     $message = "Thank you. Mail list guest subscribers have been imported.  You can now continue 
                 through the import process.";

     $this->disp_message($message,'CONFIRM');

     return $this->step_Category();

} // End of if statement.

} // End of function.

// +------------------------------------------------------------------+
// | Function: step_Category                                          |
// +------------------------------------------------------------------+

function step_Category () {

// +--
// | Importer Function Step: 
// |
// | Online Store Category Import
// +--

$this->CORE->globals('importer.step','7');
$this->CORE->globals('importer.steptext','Online Store Category Import');

// +--
// | Print the form.
// +--

$this->CORE->globals('core_cgi.import_do','0');

$software = $this->CORE->globals('importer.name');

$header = <<<ENDOFTEXT

<p>Indicate below whether you would like to import online store categories 
from your {$software} installation.</p>

ENDOFTEXT;

$fields[0]['id']       = 'import_do';
$fields[0]['name']     = 'Online Store Category Import';
$fields[0]['type']     = 'RADIO';
$fields[0]['required'] = '1';
$fields[0]['values']   = array('0' => 'Skip this step.',
                               '1' => 'Import online store categories from ' . $software . '.');

$fields[0]['desc']     = <<<ENDOFTEXT

<p>Indcate whether you would like to import the online store categories from your 
{$software} installation.  You have the option to skip this step.</p>

ENDOFTEXT;

// +--
// | Print the form.
// +--

$this->disp_form(array('header' => $header,
                       'fields' => $fields,
                       'step'   => 'CategoryP'));

// +--
// | Return true
// +--

return 1;

} // End of function.

// +------------------------------------------------------------------+
// | Function: step_CategoryP                                         |
// +------------------------------------------------------------------+

function step_CategoryP () {

// +--
// | Importer Function Step: 
// |
// | Online Store Category Import - Process
// +--

// +--
// | Make sure required fields were completed.
// +--

$fd = $this->formdata_array(array('import_pubconfig'   => 1,
                                  'import_do'          => 0));

if ($this->CORE->IsError($fd)) {return $fd;}

// +--
// | Go to the next step and print a confirm message if we're skipping
// | this step.
// +--

if (empty($fd['import_do'])) {

     $message = "Thank you. You selected to skip importing online store categories. 
                 No categories have been imported.  You can now continue through 
                 the import process.";

     $this->disp_message($message,'CONFIRM');

     return $this->step_Product();

} // End of if statement.

// +--
// | Connect to the database and define what we've got.
// +--

$this->import_load_configphp($fd['import_pubconfig']);

$this->import_connect_db();

$this->import_define_db();

$import_settings = $this->CORE->globals('importer.import_db_settings');
$import_ecomapp  = $this->CORE->globals('importer.import_db_ecomapp');

// +--
// | Handle multi-step operations.
// +--

$offset      = $this->CORE->globals('core_cgi.offset'); if (empty($offset)) {$offset = 0;}
$count       = $this->dbrows_atonce;
$rowcount    = $this->import_count_rows($import_ecomapp . '_cat');
$endnum_calc = $offset + $this->dbrows_atonce;

if ($rowcount <= $endnum_calc) {$completed = 1;} else {$completed = 0;}

$new_offset  = $offset + $this->dbrows_atonce;
$ntaskcount  = ceil($rowcount / $this->dbrows_atonce);

if ($offset == 0)     {$ntaskcurr = 1;
} elseif ($completed) {$ntaskcurr = $ntaskcount;
} else                {$ntaskcurr = ceil($new_offset / $this->dbrows_atonce);}

$mtinfo = array();

$mtinfo['currstep']   = 'CategoryP';
$mtinfo['currtask']   = 'Online Store Category Import';

$mtinfo['offset']     = $new_offset;
$mtinfo['ntaskcount'] = $ntaskcount;
$mtinfo['ntaskcurr']  = $ntaskcurr;
$mtinfo['mtcomplete'] = $completed;

$cgimtcomplete = $this->CORE->globals('core_cgi.mtcomplete');

// +--
// | Load data.
// +--

$data = $this->import_load_data($import_ecomapp . '_cat',$offset,$count);

if ((!(empty($data))) && ($rowcount > 0) && (empty($cgimtcomplete))) {

     foreach ($data as $num => $row) {

          // +--
          // | SPECIAL: Datestamp.
          // +--

          $row['datetimestamp'] = $this->CORE->globals('core_datetime.epoch');

          // +--
          // | SPECIAL: Fix ids.
          // +--

          $row['id'] = preg_replace('/[^a-zA-Z0-9\_\-]/','',$row['id']);

          $col       = 'xcat';
          $xdata     = $this->CORE->make_list($row[$col]);
          $row[$col] = '';
          foreach ($xdata as $xnum => $xid) {$row[$col] .= $xid . ', ';}
          $row[$col] = preg_replace('/ \,/','',$row[$col]);

          // +--
          // | SPECIAL: Field changes.
          // +--

          $row['subdisptype']  = 'default';
          $row['proddisptype'] = 'default';

          // +--
          // | Do the insert and don't worry about errors.  By doing an insert
          // | we don't overwrite any existing data.
          // +--

          $sql = $this->CORE_DB->clause_insert(array('table' => 'ecom_cat',
                                                     'data'  => $row));

          if (!($this->CORE->IsError($sql))) {

               $this->CORE_DB->sql_do(array('sql'   => $sql,
                                            'table' => 'ecom_cat'));

          } // End of if statement.

     } // End of foreach statement.

     // +--
     // | Present the multitask form.
     // +--

     return $this->do_multitask($mtinfo);

// +--
// | We're finished otherwise.
// +--

} else {

     $message = "Thank you. Online store categories have been imported.  You can now continue 
                 through the import process.";

     $this->disp_message($message,'CONFIRM');

     return $this->step_Product();

} // End of if statement.

} // End of function.

// +------------------------------------------------------------------+
// | Function: step_Product                                           |
// +------------------------------------------------------------------+

function step_Product () {

// +--
// | Importer Function Step: 
// |
// | Online Store Product Import
// +--

$this->CORE->globals('importer.step','8');
$this->CORE->globals('importer.steptext','Online Store Product Import');

// +--
// | Print the form.
// +--

$this->CORE->globals('core_cgi.import_do','0');

$software = $this->CORE->globals('importer.name');

$header = <<<ENDOFTEXT

<p>Indicate below whether you would like to import online store products 
from your {$software} installation.</p>

ENDOFTEXT;

$fields[0]['id']       = 'import_do';
$fields[0]['name']     = 'Online Store Product Import';
$fields[0]['type']     = 'RADIO';
$fields[0]['required'] = '1';
$fields[0]['values']   = array('0' => 'Skip this step.',
                               '1' => 'Import online store products from ' . $software . '.');

$fields[0]['desc']     = <<<ENDOFTEXT

<p>Indcate whether you would like to import the online store products from your 
{$software} installation.  You have the option to skip this step.</p>

ENDOFTEXT;

// +--
// | Print the form.
// +--

$this->disp_form(array('header' => $header,
                       'fields' => $fields,
                       'step'   => 'ProductP'));

// +--
// | Return true
// +--

return 1;

} // End of function.

// +------------------------------------------------------------------+
// | Function: step_ProductP                                          |
// +------------------------------------------------------------------+

function step_ProductP () {

// +--
// | Importer Function Step: 
// |
// | Online Store Product Import - Process
// +--

// +--
// | Make sure required fields were completed.
// +--

$fd = $this->formdata_array(array('import_pubconfig'   => 1,
                                  'import_do'          => 0));

if ($this->CORE->IsError($fd)) {return $fd;}

// +--
// | Go to the next step and print a confirm message if we're skipping
// | this step.
// +--

if (empty($fd['import_do'])) {

     $message = "Thank you. You selected to skip importing online store products. 
                 No products have been imported.  You can now continue through 
                 the import process.";

     $this->disp_message($message,'CONFIRM');

     return $this->step_ProdOpt();

} // End of if statement.

// +--
// | Connect to the database and define what we've got.
// +--

$this->import_load_configphp($fd['import_pubconfig']);

$this->import_connect_db();

$this->import_define_db();

$import_settings = $this->CORE->globals('importer.import_db_settings');
$import_ecomapp  = $this->CORE->globals('importer.import_db_ecomapp');

// +--
// | Handle multi-step operations.
// +--

$offset      = $this->CORE->globals('core_cgi.offset'); if (empty($offset)) {$offset = 0;}
$count       = $this->dbrows_atonce;
$rowcount    = $this->import_count_rows($import_ecomapp . '_prod');
$endnum_calc = $offset + $this->dbrows_atonce;

if ($rowcount <= $endnum_calc) {$completed = 1;} else {$completed = 0;}

$new_offset  = $offset + $this->dbrows_atonce;
$ntaskcount  = ceil($rowcount / $this->dbrows_atonce);

if ($offset == 0)     {$ntaskcurr = 1;
} elseif ($completed) {$ntaskcurr = $ntaskcount;
} else                {$ntaskcurr = ceil($new_offset / $this->dbrows_atonce);}

$mtinfo = array();

$mtinfo['currstep']   = 'ProductP';
$mtinfo['currtask']   = 'Online Store Product Import';

$mtinfo['offset']     = $new_offset;
$mtinfo['ntaskcount'] = $ntaskcount;
$mtinfo['ntaskcurr']  = $ntaskcurr;
$mtinfo['mtcomplete'] = $completed;

$cgimtcomplete = $this->CORE->globals('core_cgi.mtcomplete');

// +--
// | Load data.
// +--

$data = $this->import_load_data($import_ecomapp . '_prod',$offset,$count);

if ((!(empty($data))) && ($rowcount > 0) && (empty($cgimtcomplete))) {

     foreach ($data as $num => $row) {

          // +--
          // | SPECIAL: Datestamp.
          // +--

          $row['datetimestamp'] = $this->CORE->globals('core_datetime.epoch');

          // +--
          // | SPECIAL: Fix ids.
          // +--

          $row['id'] = preg_replace('/[^a-zA-Z0-9\_\-]/','',$row['id']);

          $col       = 'xcat';
          $xdata     = $this->CORE->make_list($row[$col]);
          $row[$col] = '';
          foreach ($xdata as $xnum => $xid) {$row[$col] .= $xid . ', ';}
          $row[$col] = preg_replace('/ \,/','',$row[$col]);

          $col       = 'xprod';
          $xdata     = $this->CORE->make_list($row[$col]);
          $row[$col] = '';
          foreach ($xdata as $xnum => $xid) {$row[$col] .= $xid . ', ';}
          $row[$col] = preg_replace('/ \,/','',$row[$col]);

          $col       = 'xprodoptions';
          $xdata     = $this->CORE->make_list($row[$col]);
          $row[$col] = '';
          foreach ($xdata as $xnum => $xid) {$row[$col] .= $xid . ', ';}
          $row[$col] = preg_replace('/ \,/','',$row[$col]);

          // +--
          // | SPECIAL: Field changes.
          // +--

          $row['lgdisp']     = 'default';
          $row['reviewsavg'] = '0';
          $row['reviewsnum'] = '0';

          // +--
          // | SPECIAL: Taxes.
          // +--

          if (!(empty($row['taxstateprov']))) {$row['taxstateprov'] = 'STANDARD';} else {$row['taxstateprov'] = 'EXEMPT';}
          if (!(empty($row['taxcountry'])))   {$row['taxcountry']   = 'STANDARD';} else {$row['taxcountry']   = 'EXEMPT';}

          $row['taxclass'] = 'STANDARD';

          // +--
          // | Do the insert and don't worry about errors.  By doing an insert
          // | we don't overwrite any existing data.
          // +--

          $sql = $this->CORE_DB->clause_insert(array('table' => 'ecom_prod',
                                                     'data'  => $row));

          if (!($this->CORE->IsError($sql))) {

               $this->CORE_DB->sql_do(array('sql'   => $sql,
                                            'table' => 'ecom_prod'));

          } // End of if statement.

     } // End of foreach statement.

     // +--
     // | Present the multitask form.
     // +--

     return $this->do_multitask($mtinfo);

// +--
// | We're finished otherwise.
// +--

} else {

     $message = "Thank you. Online store products have been imported.  You can now continue 
                 through the import process.";

     $this->disp_message($message,'CONFIRM');

     return $this->step_ProdOpt();

} // End of if statement.

} // End of function.

// +------------------------------------------------------------------+
// | Function: step_ProdOpt                                           |
// +------------------------------------------------------------------+

function step_ProdOpt () {

// +--
// | Importer Function Step: 
// |
// | Online Store Product Option Import
// +--

$this->CORE->globals('importer.step','9');
$this->CORE->globals('importer.steptext','Online Store Product Option Import');

// +--
// | Print the form.
// +--

$this->CORE->globals('core_cgi.import_do','0');

$software = $this->CORE->globals('importer.name');

$header = <<<ENDOFTEXT

<p>Indicate below whether you would like to import online store product options 
from your {$software} installation.</p>

ENDOFTEXT;

$fields[0]['id']       = 'import_do';
$fields[0]['name']     = 'Online Store Product Option Import';
$fields[0]['type']     = 'RADIO';
$fields[0]['required'] = '1';
$fields[0]['values']   = array('0' => 'Skip this step.',
                               '1' => 'Import online store product options from ' . $software . '.');

$fields[0]['desc']     = <<<ENDOFTEXT

<p>Indcate whether you would like to import the online store product options from your 
{$software} installation.  You have the option to skip this step.</p>

ENDOFTEXT;

// +--
// | Print the form.
// +--

$this->disp_form(array('header' => $header,
                       'fields' => $fields,
                       'step'   => 'ProdOptP'));

// +--
// | Return true
// +--

return 1;

} // End of function.

// +------------------------------------------------------------------+
// | Function: step_ProdOptP                                          |
// +------------------------------------------------------------------+

function step_ProdOptP () {

// +--
// | Importer Function Step: 
// |
// | Online Store Product Option Import - Process
// +--

// +--
// | Make sure required fields were completed.
// +--

$fd = $this->formdata_array(array('import_pubconfig'   => 1,
                                  'import_do'          => 0));

if ($this->CORE->IsError($fd)) {return $fd;}

// +--
// | Go to the next step and print a confirm message if we're skipping
// | this step.
// +--

if (empty($fd['import_do'])) {

     $message = "Thank you. You selected to skip importing online store product options. 
                 No options have been imported.  You can now continue through 
                 the import process.";

     $this->disp_message($message,'CONFIRM');

     return $this->step_ProdOptSel();

} // End of if statement.

// +--
// | Connect to the database and define what we've got.
// +--

$this->import_load_configphp($fd['import_pubconfig']);

$this->import_connect_db();

$this->import_define_db();

$import_settings = $this->CORE->globals('importer.import_db_settings');
$import_ecomapp  = $this->CORE->globals('importer.import_db_ecomapp');

// +--
// | Handle multi-step operations.
// +--

$offset      = $this->CORE->globals('core_cgi.offset'); if (empty($offset)) {$offset = 0;}
$count       = $this->dbrows_atonce;
$rowcount    = $this->import_count_rows($import_ecomapp . '_prodoptions');
$endnum_calc = $offset + $this->dbrows_atonce;

if ($rowcount <= $endnum_calc) {$completed = 1;} else {$completed = 0;}

$new_offset  = $offset + $this->dbrows_atonce;
$ntaskcount  = ceil($rowcount / $this->dbrows_atonce);

if ($offset == 0)     {$ntaskcurr = 1;
} elseif ($completed) {$ntaskcurr = $ntaskcount;
} else                {$ntaskcurr = ceil($new_offset / $this->dbrows_atonce);}

$mtinfo = array();

$mtinfo['currstep']   = 'ProdOptP';
$mtinfo['currtask']   = 'Online Store Product Option Import';

$mtinfo['offset']     = $new_offset;
$mtinfo['ntaskcount'] = $ntaskcount;
$mtinfo['ntaskcurr']  = $ntaskcurr;
$mtinfo['mtcomplete'] = $completed;

$cgimtcomplete = $this->CORE->globals('core_cgi.mtcomplete');

// +--
// | Load data.
// +--

$data = $this->import_load_data($import_ecomapp . '_prodoptions',$offset,$count);

if ((!(empty($data))) && ($rowcount > 0) && (empty($cgimtcomplete))) {

     foreach ($data as $num => $row) {

          // +--
          // | SPECIAL: Section.
          // +--

          $row['section'] = 'Item Options';

          // +--
          // | SPECIAL: Fix ids.
          // +--

          $row['id'] = preg_replace('/[^a-zA-Z0-9\_\-]/','',$row['id']);

          $col       = 'xprodoptionsel';
          $xdata     = $this->CORE->make_list($row[$col]);
          $row[$col] = '';
          foreach ($xdata as $xnum => $xid) {$row[$col] .= $xid . ', ';}
          $row[$col] = preg_replace('/ \,/','',$row[$col]);

          // +--
          // | Do the insert and don't worry about errors.  By doing an insert
          // | we don't overwrite any existing data.
          // +--

          $sql = $this->CORE_DB->clause_insert(array('table' => 'ecom_prodoptions',
                                                     'data'  => $row));

          if (!($this->CORE->IsError($sql))) {

               $this->CORE_DB->sql_do(array('sql'   => $sql,
                                            'table' => 'ecom_prodoptions'));

          } // End of if statement.

     } // End of foreach statement.

     // +--
     // | Present the multitask form.
     // +--

     return $this->do_multitask($mtinfo);

// +--
// | We're finished otherwise.
// +--

} else {

     $message = "Thank you. Online store product options have been imported.  You can now continue 
                 through the import process.";

     $this->disp_message($message,'CONFIRM');

     return $this->step_ProdOptSel();

} // End of if statement.

} // End of function.

// +------------------------------------------------------------------+
// | Function: step_ProdOptSel                                        |
// +------------------------------------------------------------------+

function step_ProdOptSel () {

// +--
// | Importer Function Step: 
// |
// | Online Store Product Option Selection Item Import
// +--

$this->CORE->globals('importer.step','9');
$this->CORE->globals('importer.steptext','Online Store Product Option Selection Item Import');

// +--
// | Print the form.
// +--

$this->CORE->globals('core_cgi.import_do','0');

$software = $this->CORE->globals('importer.name');

$header = <<<ENDOFTEXT

<p>Indicate below whether you would like to import online store product option 
selection items from your {$software} installation.</p>

ENDOFTEXT;

$fields[0]['id']       = 'import_do';
$fields[0]['name']     = 'Online Store Product Option Selection Item Import';
$fields[0]['type']     = 'RADIO';
$fields[0]['required'] = '1';
$fields[0]['values']   = array('0' => 'Skip this step.',
                               '1' => 'Import online store product option selection items from ' . $software . '.');

$fields[0]['desc']     = <<<ENDOFTEXT

<p>Indcate whether you would like to import the online store product option selection items from your 
{$software} installation.  You have the option to skip this step.</p>

ENDOFTEXT;

// +--
// | Print the form.
// +--

$this->disp_form(array('header' => $header,
                       'fields' => $fields,
                       'step'   => 'ProdOptSelP'));

// +--
// | Return true
// +--

return 1;

} // End of function.

// +------------------------------------------------------------------+
// | Function: step_ProdOptSelP                                       |
// +------------------------------------------------------------------+

function step_ProdOptSelP () {

// +--
// | Importer Function Step: 
// |
// | Online Store Product Option Selection Item Import - Process
// +--

// +--
// | Make sure required fields were completed.
// +--

$fd = $this->formdata_array(array('import_pubconfig'   => 1,
                                  'import_do'          => 0));

if ($this->CORE->IsError($fd)) {return $fd;}

// +--
// | Go to the next step and print a confirm message if we're skipping
// | this step.
// +--

if (empty($fd['import_do'])) {

     $message = "Thank you. You selected to skip importing online store product option selection. 
                 items.  No option selection items have been imported.  You can now continue through 
                 the import process.";

     $this->disp_message($message,'CONFIRM');

     return $this->step_Orders();

} // End of if statement.

// +--
// | Connect to the database and define what we've got.
// +--

$this->import_load_configphp($fd['import_pubconfig']);

$this->import_connect_db();

$this->import_define_db();

$import_settings = $this->CORE->globals('importer.import_db_settings');
$import_ecomapp  = $this->CORE->globals('importer.import_db_ecomapp');

// +--
// | Handle multi-step operations.
// +--

$offset      = $this->CORE->globals('core_cgi.offset'); if (empty($offset)) {$offset = 0;}
$count       = $this->dbrows_atonce;
$rowcount    = $this->import_count_rows($import_ecomapp . '_prodoptionsel');
$endnum_calc = $offset + $this->dbrows_atonce;

if ($rowcount <= $endnum_calc) {$completed = 1;} else {$completed = 0;}

$new_offset  = $offset + $this->dbrows_atonce;
$ntaskcount  = ceil($rowcount / $this->dbrows_atonce);

if ($offset == 0)     {$ntaskcurr = 1;
} elseif ($completed) {$ntaskcurr = $ntaskcount;
} else                {$ntaskcurr = ceil($new_offset / $this->dbrows_atonce);}

$mtinfo = array();

$mtinfo['currstep']   = 'ProdOptSelP';
$mtinfo['currtask']   = 'Online Store Product Option Import';

$mtinfo['offset']     = $new_offset;
$mtinfo['ntaskcount'] = $ntaskcount;
$mtinfo['ntaskcurr']  = $ntaskcurr;
$mtinfo['mtcomplete'] = $completed;

$cgimtcomplete = $this->CORE->globals('core_cgi.mtcomplete');

// +--
// | Load data.
// +--

$data = $this->import_load_data($import_ecomapp . '_prodoptionsel',$offset,$count);

if ((!(empty($data))) && ($rowcount > 0) && (empty($cgimtcomplete))) {

     foreach ($data as $num => $row) {

          // +--
          // | SPECIAL: Fix ids.
          // +--

          $row['id'] = preg_replace('/[^a-zA-Z0-9\_\-]/','',$row['id']);

          // +--
          // | SPECIAL: Section.
          // +--

          $row['taxstateprov'] = 'STANDARD';
          $row['taxcountry']   = 'STANDARD';
          $row['taxclass']     = 'STANDARD';

          // +--
          // | Do the insert and don't worry about errors.  By doing an insert
          // | we don't overwrite any existing data.
          // +--

          $sql = $this->CORE_DB->clause_insert(array('table' => 'ecom_prodoptionsel',
                                                     'data'  => $row));

          if (!($this->CORE->IsError($sql))) {

               $this->CORE_DB->sql_do(array('sql'   => $sql,
                                            'table' => 'ecom_prodoptionsel'));

          } // End of if statement.

     } // End of foreach statement.

     // +--
     // | Present the multitask form.
     // +--

     return $this->do_multitask($mtinfo);

// +--
// | We're finished otherwise.
// +--

} else {

     $message = "Thank you. Online store product option selection items have been imported.  
                 You can now continue through the import process.";

     $this->disp_message($message,'CONFIRM');

     return $this->step_Orders();

} // End of if statement.

} // End of function.

// +------------------------------------------------------------------+
// | Function: step_Orders                                            |
// +------------------------------------------------------------------+

function step_Orders () {

// +--
// | Importer Function Step: 
// |
// | Orders Import
// +--

$this->CORE->globals('importer.step','11');
$this->CORE->globals('importer.steptext','Orders Import');

// +--
// | Print the form.
// +--

$this->CORE->globals('core_cgi.import_do','0');

$software = $this->CORE->globals('importer.name');

$header = <<<ENDOFTEXT

<p>Indicate below whether you would like to import orders 
from your {$software} installation.</p>

ENDOFTEXT;

$fields[0]['id']       = 'import_do';
$fields[0]['name']     = 'Orders Import';
$fields[0]['type']     = 'RADIO';
$fields[0]['required'] = '1';
$fields[0]['values']   = array('0' => 'Skip this step.',
                               '1' => 'Import Orders from ' . $software . '.');

$fields[0]['desc']     = <<<ENDOFTEXT

<p>Indcate whether you would like to import the orders from your 
{$software} installation.  You have the option to skip this step.</p>

ENDOFTEXT;

// +--
// | Print the form.
// +--

$this->disp_form(array('header' => $header,
                       'fields' => $fields,
                       'step'   => 'OrdersP'));

// +--
// | Return true
// +--

return 1;

} // End of function.

// +------------------------------------------------------------------+
// | Function: step_OrdersP                                           |
// +------------------------------------------------------------------+

function step_OrdersP () {

// +--
// | Importer Function Step: 
// |
// | Orders Import - Process
// +--

// +--
// | Make sure required fields were completed.
// +--

$fd = $this->formdata_array(array('import_pubconfig'   => 1,
                                  'import_do'          => 0));

if ($this->CORE->IsError($fd)) {return $fd;}

// +--
// | Go to the next step and print a confirm message if we're skipping
// | this step.
// +--

if (empty($fd['import_do'])) {

     $message = "Thank you. You selected to skip importing Orders. 
                 No orders have been imported.  You can now continue through 
                 the import process.";

     $this->disp_message($message,'CONFIRM');

     return $this->step_OrderItems();

} // End of if statement.

// +--
// | Connect to the database and define what we've got.
// +--

$this->import_load_configphp($fd['import_pubconfig']);

$this->import_connect_db();

$this->import_define_db();

$import_settings = $this->CORE->globals('importer.import_db_settings');
$import_ecomapp  = $this->CORE->globals('importer.import_db_ecomapp');

// +--
// | Handle multi-step operations.
// +--

$offset      = $this->CORE->globals('core_cgi.offset'); if (empty($offset)) {$offset = 0;}
$count       = $this->dbrows_atonce;
$rowcount    = $this->import_count_rows($import_ecomapp . '_orders');
$endnum_calc = $offset + $this->dbrows_atonce;

if ($rowcount <= $endnum_calc) {$completed = 1;} else {$completed = 0;}

$new_offset  = $offset + $this->dbrows_atonce;
$ntaskcount  = ceil($rowcount / $this->dbrows_atonce);

if ($offset == 0)     {$ntaskcurr = 1;
} elseif ($completed) {$ntaskcurr = $ntaskcount;
} else                {$ntaskcurr = ceil($new_offset / $this->dbrows_atonce);}

$mtinfo = array();

$mtinfo['currstep']   = 'OrdersP';
$mtinfo['currtask']   = 'Orders Import';

$mtinfo['offset']     = $new_offset;
$mtinfo['ntaskcount'] = $ntaskcount;
$mtinfo['ntaskcurr']  = $ntaskcurr;
$mtinfo['mtcomplete'] = $completed;

$cgimtcomplete = $this->CORE->globals('core_cgi.mtcomplete');

// +--
// | Load data.
// +--

$data = $this->import_load_data($import_ecomapp . '_orders',$offset,$count);

if ((!(empty($data))) && ($rowcount > 0) && (empty($cgimtcomplete))) {

     foreach ($data as $num => $row) {

          // +--
          // | SPECIAL: Section.
          // +--

          $row['custsurchargetotal'] = '0.00';
          $row['taxcreftotal']       = '0.00';
          $row['loyaltypointstotal'] = '0.00';

          // +--
          // | Do the insert and don't worry about errors.  By doing an insert
          // | we don't overwrite any existing data.
          // +--

          $sql = $this->CORE_DB->clause_insert(array('table' => 'ecom_orders',
                                                     'data'  => $row));

          if (!($this->CORE->IsError($sql))) {

               $this->CORE_DB->sql_do(array('sql'   => $sql,
                                            'table' => 'ecom_orders'));

          } // End of if statement.

     } // End of foreach statement.

     // +--
     // | Present the multitask form.
     // +--

     return $this->do_multitask($mtinfo);

// +--
// | We're finished otherwise.
// +--

} else {

     $message = "Thank you. Orders have been imported.  You can now continue 
                 through the import process.";

     $this->disp_message($message,'CONFIRM');

     return $this->step_OrderItems();

} // End of if statement.

} // End of function.

// +------------------------------------------------------------------+
// | Function: step_OrderItems                                        |
// +------------------------------------------------------------------+

function step_OrderItems () {

// +--
// | Importer Function Step: 
// |
// | Online Order Items Import
// +--

$this->CORE->globals('importer.step','12');
$this->CORE->globals('importer.steptext','Online Order Items Import');

// +--
// | Print the form.
// +--

$this->CORE->globals('core_cgi.import_do','0');

$software = $this->CORE->globals('importer.name');

$header = <<<ENDOFTEXT

<p>Indicate below whether you would like to import online order items 
from your {$software} installation.</p>

ENDOFTEXT;

$fields[0]['id']       = 'import_do';
$fields[0]['name']     = 'Online Order Items Import';
$fields[0]['type']     = 'RADIO';
$fields[0]['required'] = '1';
$fields[0]['values']   = array('0' => 'Skip this step.',
                               '1' => 'Import Online Order Items from ' . $software . '.');

$fields[0]['desc']     = <<<ENDOFTEXT

<p>Indcate whether you would like to import the online order items from your 
{$software} installation.  You have the option to skip this step.</p>

ENDOFTEXT;

// +--
// | Print the form.
// +--

$this->disp_form(array('header' => $header,
                       'fields' => $fields,
                       'step'   => 'OrderItemsP'));

// +--
// | Return true
// +--

return 1;

} // End of function.

// +------------------------------------------------------------------+
// | Function: step_OrderItemsP                                       |
// +------------------------------------------------------------------+

function step_OrderItemsP () {

// +--
// | Importer Function Step: 
// |
// | Online Order Items Import - Process
// +--

// +--
// | Make sure required fields were completed.
// +--

$fd = $this->formdata_array(array('import_pubconfig'   => 1,
                                  'import_do'          => 0));

if ($this->CORE->IsError($fd)) {return $fd;}

// +--
// | Go to the next step and print a confirm message if we're skipping
// | this step.
// +--

if (empty($fd['import_do'])) {

     $message = "Thank you. You selected to skip importing Online Order Items. 
                 No online order items have been imported.  You can now continue through 
                 the import process.";

     $this->disp_message($message,'CONFIRM');

     return $this->step_Discounts();

} // End of if statement.

// +--
// | Connect to the database and define what we've got.
// +--

$this->import_load_configphp($fd['import_pubconfig']);

$this->import_connect_db();

$this->import_define_db();

$import_settings = $this->CORE->globals('importer.import_db_settings');
$import_ecomapp  = $this->CORE->globals('importer.import_db_ecomapp');

// +--
// | Handle multi-step operations.
// +--

$offset      = $this->CORE->globals('core_cgi.offset'); if (empty($offset)) {$offset = 0;}
$count       = $this->dbrows_atonce;
$rowcount    = $this->import_count_rows($import_ecomapp . '_orderitems');
$endnum_calc = $offset + $this->dbrows_atonce;

if ($rowcount <= $endnum_calc) {$completed = 1;} else {$completed = 0;}

$new_offset  = $offset + $this->dbrows_atonce;
$ntaskcount  = ceil($rowcount / $this->dbrows_atonce);

if ($offset == 0)     {$ntaskcurr = 1;
} elseif ($completed) {$ntaskcurr = $ntaskcount;
} else                {$ntaskcurr = ceil($new_offset / $this->dbrows_atonce);}

$mtinfo = array();

$mtinfo['currstep']   = 'OrderItemsP';
$mtinfo['currtask']   = 'Online Order Items Import';

$mtinfo['offset']     = $new_offset;
$mtinfo['ntaskcount'] = $ntaskcount;
$mtinfo['ntaskcurr']  = $ntaskcurr;
$mtinfo['mtcomplete'] = $completed;

$cgimtcomplete = $this->CORE->globals('core_cgi.mtcomplete');

// +--
// | Load data.
// +--

$data = $this->import_load_data($import_ecomapp . '_orderitems',$offset,$count);

if ((!(empty($data))) && ($rowcount > 0) && (empty($cgimtcomplete))) {

     foreach ($data as $num => $row) {

          // +--
          // | Do the insert and don't worry about errors.  By doing an insert
          // | we don't overwrite any existing data.
          // +--

          $sql = $this->CORE_DB->clause_insert(array('table' => 'ecom_orderitems',
                                                     'data'  => $row));

          if (!($this->CORE->IsError($sql))) {

               $this->CORE_DB->sql_do(array('sql'   => $sql,
                                            'table' => 'ecom_orderitems'));

          } // End of if statement.

     } // End of foreach statement.

     // +--
     // | Present the multitask form.
     // +--

     return $this->do_multitask($mtinfo);

// +--
// | We're finished otherwise.
// +--

} else {

     $message = "Thank you. Online order items have been imported.  You can now continue 
                 through the import process.";

     $this->disp_message($message,'CONFIRM');

     return $this->step_Discounts();

} // End of if statement.

} // End of function.

// +------------------------------------------------------------------+
// | Function: step_Discounts                                         |
// +------------------------------------------------------------------+

function step_Discounts () {

// +--
// | Importer Function Step: 
// |
// | Discount Code Import
// +--

$this->CORE->globals('importer.step','13');
$this->CORE->globals('importer.steptext','Discount Code Import');

// +--
// | Print the form.
// +--

$this->CORE->globals('core_cgi.import_do','0');

$software = $this->CORE->globals('importer.name');

$header = <<<ENDOFTEXT

<p>Indicate below whether you would like to import discount codes 
from your {$software} installation.</p>

ENDOFTEXT;

$fields[0]['id']       = 'import_do';
$fields[0]['name']     = 'Discount Code Import';
$fields[0]['type']     = 'RADIO';
$fields[0]['required'] = '1';
$fields[0]['values']   = array('0' => 'Skip this step.',
                               '1' => 'Import Discount Codes from ' . $software . '.');

$fields[0]['desc']     = <<<ENDOFTEXT

<p>Indcate whether you would like to import the discount codes from your 
{$software} installation.  You have the option to skip this step.</p>

ENDOFTEXT;

// +--
// | Print the form.
// +--

$this->disp_form(array('header' => $header,
                       'fields' => $fields,
                       'step'   => 'DiscountsP'));

// +--
// | Return true
// +--

return 1;

} // End of function.

// +------------------------------------------------------------------+
// | Function: step_DiscountsP                                        |
// +------------------------------------------------------------------+

function step_DiscountsP () {

// +--
// | Importer Function Step: 
// |
// | Discount Code Import - Process
// +--

// +--
// | Make sure required fields were completed.
// +--

$fd = $this->formdata_array(array('import_pubconfig'   => 1,
                                  'import_do'          => 0));

if ($this->CORE->IsError($fd)) {return $fd;}

// +--
// | Go to the next step and print a confirm message if we're skipping
// | this step.
// +--

if (empty($fd['import_do'])) {

     $message = "Thank you. You selected to skip importing Discount Codes. 
                 No discount codes have been imported.  You can now continue through 
                 the import process.";

     $this->disp_message($message,'CONFIRM');

     return $this->step_HtmlPage();

} // End of if statement.

// +--
// | Connect to the database and define what we've got.
// +--

$this->import_load_configphp($fd['import_pubconfig']);

$this->import_connect_db();

$this->import_define_db();

$import_settings = $this->CORE->globals('importer.import_db_settings');
$import_ecomapp  = $this->CORE->globals('importer.import_db_ecomapp');

// +--
// | Handle multi-step operations.
// +--

$offset      = $this->CORE->globals('core_cgi.offset'); if (empty($offset)) {$offset = 0;}
$count       = $this->dbrows_atonce;
$rowcount    = $this->import_count_rows($import_ecomapp . '_discounts');
$endnum_calc = $offset + $this->dbrows_atonce;

if ($rowcount <= $endnum_calc) {$completed = 1;} else {$completed = 0;}

$new_offset  = $offset + $this->dbrows_atonce;
$ntaskcount  = ceil($rowcount / $this->dbrows_atonce);

if ($offset == 0)     {$ntaskcurr = 1;
} elseif ($completed) {$ntaskcurr = $ntaskcount;
} else                {$ntaskcurr = ceil($new_offset / $this->dbrows_atonce);}

$mtinfo = array();

$mtinfo['currstep']   = 'DiscountsP';
$mtinfo['currtask']   = 'Discount Code Import';

$mtinfo['offset']     = $new_offset;
$mtinfo['ntaskcount'] = $ntaskcount;
$mtinfo['ntaskcurr']  = $ntaskcurr;
$mtinfo['mtcomplete'] = $completed;

$cgimtcomplete = $this->CORE->globals('core_cgi.mtcomplete');

// +--
// | Load data.
// +--

$data = $this->import_load_data($import_ecomapp . '_discounts',$offset,$count);

if ((!(empty($data))) && ($rowcount > 0) && (empty($cgimtcomplete))) {

     foreach ($data as $num => $row) {

          // +--
          // | SPECIAL: Include discount in shipping.
          // +--

          $row['inclship'] = '0';

          // +--
          // | Do the insert and don't worry about errors.  By doing an insert
          // | we don't overwrite any existing data.
          // +--

          $sql = $this->CORE_DB->clause_insert(array('table' => 'ecom_discounts',
                                                     'data'  => $row));

          if (!($this->CORE->IsError($sql))) {

               $this->CORE_DB->sql_do(array('sql'   => $sql,
                                            'table' => 'ecom_discounts'));

          } // End of if statement.

     } // End of foreach statement.

     // +--
     // | Present the multitask form.
     // +--

     return $this->do_multitask($mtinfo);

// +--
// | We're finished otherwise.
// +--

} else {

     $message = "Thank you. Discount codes have been imported.  You can now continue 
                 through the import process.";

     $this->disp_message($message,'CONFIRM');

     return $this->step_HtmlPage();

} // End of if statement.

} // End of function.

// +------------------------------------------------------------------+
// | Function: step_HtmlPage                                          |
// +------------------------------------------------------------------+

function step_HtmlPage () {

// +--
// | Importer Function Step: 
// |
// | HTML Page Import
// +--

$this->CORE->globals('importer.step','14');
$this->CORE->globals('importer.steptext','HTML Page Import');

// +--
// | Print the form.
// +--

$this->CORE->globals('core_cgi.import_do','0');

$software = $this->CORE->globals('importer.name');

$header = <<<ENDOFTEXT

<p>Indicate below whether you would like to import HTML pages 
from your {$software} installation.  HTML pages imported are of the 
user-defined type.</p>

ENDOFTEXT;

$fields[0]['id']       = 'import_do';
$fields[0]['name']     = 'HTML Page Import';
$fields[0]['type']     = 'RADIO';
$fields[0]['required'] = '1';
$fields[0]['values']   = array('0' => 'Skip this step.',
                               '1' => 'Import HTML Pages from ' . $software . '.');

$fields[0]['desc']     = <<<ENDOFTEXT

<p>Indcate whether you would like to import the HTML pages from your 
{$software} installation.  You have the option to skip this step.</p>

ENDOFTEXT;

// +--
// | Print the form.
// +--

$this->disp_form(array('header' => $header,
                       'fields' => $fields,
                       'step'   => 'HtmlPageP'));

// +--
// | Return true
// +--

return 1;

} // End of function.

// +------------------------------------------------------------------+
// | Function: step_HtmlPageP                                         |
// +------------------------------------------------------------------+

function step_HtmlPageP () {

// +--
// | Importer Function Step: 
// |
// | HTML Page Import - Process
// +--

// +--
// | Make sure required fields were completed.
// +--

$fd = $this->formdata_array(array('import_pubconfig'   => 1,
                                  'import_do'          => 0));

if ($this->CORE->IsError($fd)) {return $fd;}

// +--
// | Go to the next step and print a confirm message if we're skipping
// | this step.
// +--

if (empty($fd['import_do'])) {

     $message = "Thank you. You selected to skip importing HTML Pages. 
                 No HTML pages have been imported.";

     $this->disp_message($message,'CONFIRM');

     return $this->step_DynForm();

} // End of if statement.

// +--
// | Connect to the database and define what we've got.
// +--

$this->import_load_configphp($fd['import_pubconfig']);

$this->import_connect_db();

$this->import_define_db();

$import_settings = $this->CORE->globals('importer.import_db_settings');
$import_ecomapp  = $this->CORE->globals('importer.import_db_ecomapp');

// +--
// | Handle multi-step operations.
// +--

$offset      = $this->CORE->globals('core_cgi.offset'); if (empty($offset)) {$offset = 0;}
$count       = $this->dbrows_atonce;
$rowcount    = $this->import_count_rows($import_ecomapp . '_html');
$endnum_calc = $offset + $this->dbrows_atonce;

if ($rowcount <= $endnum_calc) {$completed = 1;} else {$completed = 0;}

$new_offset  = $offset + $this->dbrows_atonce;
$ntaskcount  = ceil($rowcount / $this->dbrows_atonce);

if ($offset == 0)     {$ntaskcurr = 1;
} elseif ($completed) {$ntaskcurr = $ntaskcount;
} else                {$ntaskcurr = ceil($new_offset / $this->dbrows_atonce);}

$mtinfo = array();

$mtinfo['currstep']   = 'HtmlPageP';
$mtinfo['currtask']   = 'HTML Page Import';

$mtinfo['offset']     = $new_offset;
$mtinfo['ntaskcount'] = $ntaskcount;
$mtinfo['ntaskcurr']  = $ntaskcurr;
$mtinfo['mtcomplete'] = $completed;

$cgimtcomplete = $this->CORE->globals('core_cgi.mtcomplete');

// +--
// | Load data.
// +--

$data = $this->import_load_data($import_ecomapp . '_html',$offset,$count);

if ((!(empty($data))) && ($rowcount > 0) && (empty($cgimtcomplete))) {

     foreach ($data as $num => $row) {

          // +--
          // | SPECIAL: Fix content.
          // +--

          $row['htmlcontent'] = $this->import_fix_content($row['htmlcontent']);

          // +--
          // | SPECIAL: Datestamp.
          // +--

          $row['datetimestamp'] = $this->CORE->globals('core_datetime.epoch');

          // +--
          // | SPECIAL: Visibility.
          // +--

          $row['htmlview']  = 'A';
          $row['htmlviewg'] = '';

          // +--
          // | Just update the splash page if that's the one we're working with.
          // +--

          if ($row['id'] == 'splash') {

               $data = $row; unset($data['id']);
               
               $update_clause = $this->CORE_DB->clause_update(array('table'      => 'cms_html',
                                                                    'data'       => $data));

               if (!($this->CORE->IsError($update_clause))) {

                    $sql = $update_clause . " WHERE id=" . $this->CORE_DB->quote('splash');

                    $result = $this->CORE_DB->sql_do(array('sql'   => $sql,
                                                           'table' => 'cms_html'));

                } // End of if statement.

          // +--
          // | Otherwise, do the insert and don't worry about errors.  By doing an insert
          // | we don't overwrite any existing data.
          // +--

          } else {

               $sql = $this->CORE_DB->clause_insert(array('table' => 'cms_html',
                                                          'data'  => $row));
  
               if (!($this->CORE->IsError($sql))) {
 
                    $this->CORE_DB->sql_do(array('sql'   => $sql,
                                                 'table' => 'cms_html'));

               } // End of if statement.

          } // End of if statement.

     } // End of foreach statement.

     // +--
     // | Present the multitask form.
     // +--

     return $this->do_multitask($mtinfo);

// +--
// | We're finished otherwise.
// +--

} else {

     $message = "Thank you. HTML pages have been imported.  You can now continue 
                 through the import process.";

     $this->disp_message($message,'CONFIRM');

     return $this->step_DynForm();

} // End of if statement.

} // End of function.

// +------------------------------------------------------------------+
// | Function: step_DynForm                                           |
// +------------------------------------------------------------------+

function step_DynForm () {

// +--
// | Importer Function Step: 
// |
// | Dynamic Form Import
// +--

$this->CORE->globals('importer.step','15');
$this->CORE->globals('importer.steptext','Dynamic Form Import');

// +--
// | Print the form.
// +--

$this->CORE->globals('core_cgi.import_do','0');

$software = $this->CORE->globals('importer.name');

$header = <<<ENDOFTEXT

<p>Indicate below whether you would like to import dynamic forms 
from your {$software} installation.</p>

ENDOFTEXT;

$fields[0]['id']       = 'import_do';
$fields[0]['name']     = 'Dynamic Form Import';
$fields[0]['type']     = 'RADIO';
$fields[0]['required'] = '1';
$fields[0]['values']   = array('0' => 'Skip this step.',
                               '1' => 'Import Dynamic Forms from ' . $software . '.');

$fields[0]['desc']     = <<<ENDOFTEXT

<p>Indcate whether you would like to import the dynamic forms from your 
{$software} installation.  You have the option to skip this step.</p>

ENDOFTEXT;

// +--
// | Print the form.
// +--

$this->disp_form(array('header' => $header,
                       'fields' => $fields,
                       'step'   => 'DynFormP'));

// +--
// | Return true
// +--

return 1;

} // End of function.

// +------------------------------------------------------------------+
// | Function: step_DynFormP                                          |
// +------------------------------------------------------------------+

function step_DynFormP () {

// +--
// | Importer Function Step: 
// |
// | Dynamic Form Import - Process
// +--

// +--
// | Make sure required fields were completed.
// +--

$fd = $this->formdata_array(array('import_pubconfig'   => 1,
                                  'import_do'          => 0));

if ($this->CORE->IsError($fd)) {return $fd;}

// +--
// | Go to the next step and print a confirm message if we're skipping
// | this step.
// +--

if (empty($fd['import_do'])) {

     $message = "Thank you. You selected to skip importing Dynamic Forms. 
                 No dynamic forms have been imported.";

     $this->disp_message($message,'CONFIRM');

     return $this->step_DynFormFld();

} // End of if statement.

// +--
// | Connect to the database and define what we've got.
// +--

$this->import_load_configphp($fd['import_pubconfig']);

$this->import_connect_db();

$this->import_define_db();

$import_settings = $this->CORE->globals('importer.import_db_settings');
$import_ecomapp  = $this->CORE->globals('importer.import_db_ecomapp');

// +--
// | Handle multi-step operations.
// +--

$offset      = $this->CORE->globals('core_cgi.offset'); if (empty($offset)) {$offset = 0;}
$count       = $this->dbrows_atonce;
$rowcount    = $this->import_count_rows($import_ecomapp . '_dynforms');
$endnum_calc = $offset + $this->dbrows_atonce;

if ($rowcount <= $endnum_calc) {$completed = 1;} else {$completed = 0;}

$new_offset  = $offset + $this->dbrows_atonce;
$ntaskcount  = ceil($rowcount / $this->dbrows_atonce);

if ($offset == 0)     {$ntaskcurr = 1;
} elseif ($completed) {$ntaskcurr = $ntaskcount;
} else                {$ntaskcurr = ceil($new_offset / $this->dbrows_atonce);}

$mtinfo = array();

$mtinfo['currstep']   = 'DynFormP';
$mtinfo['currtask']   = 'Dynamic Form Import';

$mtinfo['offset']     = $new_offset;
$mtinfo['ntaskcount'] = $ntaskcount;
$mtinfo['ntaskcurr']  = $ntaskcurr;
$mtinfo['mtcomplete'] = $completed;

$cgimtcomplete = $this->CORE->globals('core_cgi.mtcomplete');

// +--
// | Load data.
// +--

$data = $this->import_load_data($import_ecomapp . '_dynforms',$offset,$count);

if ((!(empty($data))) && ($rowcount > 0) && (empty($cgimtcomplete))) {

     foreach ($data as $num => $row) {

          // +--
          // | Do the insert and don't worry about errors.  By doing an insert
          // | we don't overwrite any existing data.
          // +--

          $sql = $this->CORE_DB->clause_insert(array('table' => 'cms_dynforms',
                                                     'data'  => $row));

          if (!($this->CORE->IsError($sql))) {

               $this->CORE_DB->sql_do(array('sql'   => $sql,
                                            'table' => 'cms_dynforms'));

          } // End of if statement.

     } // End of foreach statement.

     // +--
     // | Present the multitask form.
     // +--

     return $this->do_multitask($mtinfo);

// +--
// | We're finished otherwise.
// +--

} else {

     $message = "Thank you. Dynamic forms have been imported.  You can now continue 
                 through the import process.";

     $this->disp_message($message,'CONFIRM');

     return $this->step_DynFormFld();

} // End of if statement.

} // End of function.

// +------------------------------------------------------------------+
// | Function: step_DynFormFld                                        |
// +------------------------------------------------------------------+

function step_DynFormFld () {

// +--
// | Importer Function Step: 
// |
// | Dynamic Form Field Import
// +--

$this->CORE->globals('importer.step','16');
$this->CORE->globals('importer.steptext','Dynamic Form Field Import');

// +--
// | Print the form.
// +--

$this->CORE->globals('core_cgi.import_do','0');

$software = $this->CORE->globals('importer.name');

$header = <<<ENDOFTEXT

<p>Indicate below whether you would like to import dynamic form fields 
from your {$software} installation.</p>

ENDOFTEXT;

$fields[0]['id']       = 'import_do';
$fields[0]['name']     = 'Dynamic Form Field Import';
$fields[0]['type']     = 'RADIO';
$fields[0]['required'] = '1';
$fields[0]['values']   = array('0' => 'Skip this step.',
                               '1' => 'Import Dynamic Form Fields from ' . $software . '.');

$fields[0]['desc']     = <<<ENDOFTEXT

<p>Indcate whether you would like to import the dynamic form fields from your 
{$software} installation.  You have the option to skip this step.</p>

ENDOFTEXT;

// +--
// | Print the form.
// +--

$this->disp_form(array('header' => $header,
                       'fields' => $fields,
                       'step'   => 'DynFormFldP'));

// +--
// | Return true
// +--

return 1;

} // End of function.

// +------------------------------------------------------------------+
// | Function: step_DynFormFldP                                       |
// +------------------------------------------------------------------+

function step_DynFormFldP () {

// +--
// | Importer Function Step: 
// |
// | Dynamic Form Field Import - Process
// +--

// +--
// | Make sure required fields were completed.
// +--

$fd = $this->formdata_array(array('import_pubconfig'   => 1,
                                  'import_do'          => 0));

if ($this->CORE->IsError($fd)) {return $fd;}

// +--
// | Go to the next step and print a confirm message if we're skipping
// | this step.
// +--

if (empty($fd['import_do'])) {

     $message = "Thank you. You selected to skip importing Dynamic Form Fields. 
                 No dynamic form fields have been imported.";

     $this->disp_message($message,'CONFIRM');

     return $this->step_Final();

} // End of if statement.

// +--
// | Connect to the database and define what we've got.
// +--

$this->import_load_configphp($fd['import_pubconfig']);

$this->import_connect_db();

$this->import_define_db();

$import_settings = $this->CORE->globals('importer.import_db_settings');
$import_ecomapp  = $this->CORE->globals('importer.import_db_ecomapp');

// +--
// | Handle multi-step operations.
// +--

$offset      = $this->CORE->globals('core_cgi.offset'); if (empty($offset)) {$offset = 0;}
$count       = $this->dbrows_atonce;
$rowcount    = $this->import_count_rows($import_ecomapp . '_dynformfields');
$endnum_calc = $offset + $this->dbrows_atonce;

if ($rowcount <= $endnum_calc) {$completed = 1;} else {$completed = 0;}

$new_offset  = $offset + $this->dbrows_atonce;
$ntaskcount  = ceil($rowcount / $this->dbrows_atonce);

if ($offset == 0)     {$ntaskcurr = 1;
} elseif ($completed) {$ntaskcurr = $ntaskcount;
} else                {$ntaskcurr = ceil($new_offset / $this->dbrows_atonce);}

$mtinfo = array();

$mtinfo['currstep']   = 'DynFormFldP';
$mtinfo['currtask']   = 'Dynamic Form Field Import';

$mtinfo['offset']     = $new_offset;
$mtinfo['ntaskcount'] = $ntaskcount;
$mtinfo['ntaskcurr']  = $ntaskcurr;
$mtinfo['mtcomplete'] = $completed;

$cgimtcomplete = $this->CORE->globals('core_cgi.mtcomplete');

// +--
// | Load data.
// +--

$data = $this->import_load_data($import_ecomapp . '_dynformfields',$offset,$count);

if ((!(empty($data))) && ($rowcount > 0) && (empty($cgimtcomplete))) {

     foreach ($data as $num => $row) {

          // +--
          // | Do the insert and don't worry about errors.  By doing an insert
          // | we don't overwrite any existing data.
          // +--

          $sql = $this->CORE_DB->clause_insert(array('table' => 'cms_dynformfields',
                                                     'data'  => $row));

          if (!($this->CORE->IsError($sql))) {

               $this->CORE_DB->sql_do(array('sql'   => $sql,
                                            'table' => 'cms_dynformfields'));

          } // End of if statement.

     } // End of foreach statement.

     // +--
     // | Present the multitask form.
     // +--

     return $this->do_multitask($mtinfo);

// +--
// | We're finished otherwise.
// +--

} else {

     $message = "Thank you. Dynamic form fields have been imported.  You can now continue 
                 through the import process.";

     $this->disp_message($message,'CONFIRM');

     return $this->step_Final();

} // End of if statement.

} // End of function.

// +------------------------------------------------------------------+
// | Function: step_Final                                             |
// +------------------------------------------------------------------+

function step_Final () {

// +--
// | Importer Function Step.
// +--

// +--
// | Define variables for the confirm display.
// +--

$link     = $this->CORE->globals('core.script_backend');

// +--
// | Final Confirm Display
// +--

print <<<ENDOFTEXT

<p>The data import process has completed.  The data you chose to import 
has been saved to the primary database connection and the 
filesystem used by this software.</p>

<p><a href="{$link}" title="Management Interface">Click here to run 
the Management Interface.</a></p>

ENDOFTEXT;

// +--
// | Return true.
// +--

return 1;

} // End of function.

// +------------------------------------------------------------------+
// |------------------------------------------------------------------|
// |------------------------------------------------------------------|
// |                                                                  |
// | Importer Display                                                 |
// |                                                                  |
// |------------------------------------------------------------------|
// |------------------------------------------------------------------|
// +------------------------------------------------------------------+

// +------------------------------------------------------------------+
// | Function: disp                                                   |
// +------------------------------------------------------------------+

function disp () {

// +--
// | This function displays the importer screen output.
// +--

// +--
// | Define our date for our copyright and our EOL.
// +--

$date_year = @date('Y');
$eol       = $this->CORE->globals('core.eol');

$title_add = '';

if ($this->CORE->globals('importer.steptext')) {

     $title_add = ' - ' . $this->CORE->xhtml_translate($this->CORE->globals('importer.steptext'),'ENCODE');

} // End of if statement.

// +--
// | Print the header section.
// +--

print <<<ENDOFTEXT

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">

<html xmlns="http://www.w3.org/1999/xhtml">

<head>

<meta http-equiv="content-type" content="text/html; charset=ISO-8859-1" /> 

<style type="text/css" media="all">

body {
     font-family: Verdana, Tahoma, Arial, sans-serif;
     font-size: 11px;
     color: #333333;
     font-weight: normal;
     text-align: left;
     background-color: #F5F5F5;
     margin: 20px;
     font-size: 12px;
     }

a {
     color: #30569D;
     text-decoration: underline;
     font-weight: normal;
     }

a:hover {
     color: #333333;
     text-decoration: underline;
     }

.strong {
     font-weight: bold;
     }

fieldset {
     border: none;
     padding: 0px;
     margin-bottom: 15px;
     }

legend {
     display: none;
     }


label {
     display: none;
     }

fieldset p {
     display: block;
     margin: 0px 0px 8px 0px;
     }

#header {
     border-top: 1px solid #333333;
     border-left: 1px solid #333333;
     border-right: 1px solid #333333;
     width: 620px;
     padding: 0px;
     margin: 0px auto 0px auto;
     background-image: url('//central.kryptronic.com/public/media/header_europacart.png');
     background-position: top left;
     background-repeat: no-repeat;
     height: 50px;
     -moz-border-radius: 8px 8px 0px 0px;
     -webkit-border-radius: 8px 8px 0px 0px;
     border-radius: 8px 8px 0px 0px;
     -moz-box-shadow: 2px 2px 2px #333333;
     -webkit-box-shadow: 2px 2px 2px #333333;
     box-shadow: 2px 2px 2px #333333;
     }

#content {
     color: #333333;
     background-color: #FFFFFF;
     border-bottom: 1px solid #333333;
     border-left: 1px solid #333333;
     border-right: 1px solid #333333;
     width: 600px;
     padding: 10px;
     margin: auto;
     -moz-border-radius: 0px 0px 8px 8px;
     -webkit-border-radius: 0px 0px 8px 8px;
     border-radius: 0px 0px 8px 8px;
     -moz-box-shadow: 2px 2px 2px #333333;
     -webkit-box-shadow: 2px 2px 2px #333333;
     box-shadow: 2px 2px 2px #333333;
     line-height: 1.25em;
     }

#pgtitle {
     color: #4E70AE;
     padding: 0px;
     margin: 0px 0px 10px 0px;
     font-weight: bold;
     font-size: 18px;
     }

.formfieldleg {
     border-top: 1px solid #DEDEDE;
     padding-top: 10px;
     font-weight: bold;
     }

.formfieldinstruct {
     color: #30569D;
     font-size: 11px;
     margin: 5px 0px 5px 0px;
     }

#meter {
     width: auto;
     margin: 20px 0px 10px 0px;
     }

p.meter {
     color: #333333;
     display: inline;
     }

p.metercomp {
     background-color: #339933;
     color: #339933;
     display: inline;
     font-weight: bold;
     padding: 5px 0px 5px 0px;
     }

p.meterpend {
     background-color: #CCCCCC;
     color: #CCCCCC;
     display: inline;
     font-weight: bold;
     padding: 5px 0px 5px 0px;
     }

.msgerror {
     color: #FF0000;
     font-weight: bold;
     }

.msgconf {
     color: #339933;
     font-weight: bold;
     }

.hidden {
     display: none;
     }

.formfieldradcb {
     color: inherit;
     background-color: inherit;
     margin-bottom: 4px;
     border: none;
     }

.formfield {
     background-color: #FFFFFF;
     border: 1px solid #8C867B;
     margin: 5px 5px 0px 0px;
     font-family: Arial, Helvetica, sans-serif;
     font-size: 12px;
     padding: 2px;
     }

.formfield:focus {
     background-color: #FFFFDD;
     border: 1px solid #FFCC66;
     }

select.formfield {
     -moz-border-radius: 6px 0px 0px 6px;
     -webkit-border-radius: 6px 0px 0px 6px;
     border-radius: 6px 0px 0px 6px;
     }

input.formfield, textarea.formfield {
     -moz-border-radius: 6px 6px 6px 6px;
     -webkit-border-radius: 6px 6px 6px 6px;
     border-radius: 6px 6px 6px 6px;
     }

.formbutton {
     color: #333333;
     background-color: #DEDEDE;
     padding: 1px;
     margin-top: 5px;
     margin-left: 2px;
     font-weight: bold;
     width: 100px;
     font-size: 11px;
     border: 1px solid #333333;
     -moz-border-radius: 6px 6px 6px 6px;
     -webkit-border-radius: 6px 6px 6px 6px;
     border-radius: 6px 6px 6px 6px;
     }

.formbutton:hover {
     color: #333333;
     background-color: #EFEFEF;
     -moz-border-radius: 6px 6px 6px 6px;
     -webkit-border-radius: 6px 6px 6px 6px;
     border-radius: 6px 6px 6px 6px;
     }

</style>

<title>Software Data Importer{$title_add}</title>

<script type="text/javascript" src="//central.kryptronic.com/public/jquery/jquery.min.js"></script>
<script type="text/javascript">jQuery.noConflict();</script>

<script type="text/javascript">

jQuery(document).ready(function(){

     jQuery('input:submit').click(function(){

          if (jQuery(this).prop('value') == 'Cancel') {return true;}

          if (jQuery(this).hasClass('disabled')) {return false;}

          jQuery(this).addClass('disabled');

          jQuery(this).prop('value','Please Wait...');

          return true;

     });

ENDOFTEXT;

if ($this->CORE->globals('importer.auto_submit')) {print '     jQuery(\'#importer\').submit();' . $eol;}

print <<<ENDOFTEXT

     jQuery('a[rel=\'external\']').prop('target', '_blank');

});

jQuery(window).unload(function() {

     jQuery('input:submit').removeClass('disabled');

});

</script>

</head>

<body>

<div id="header">&nbsp;</div>

<div id="content">

ENDOFTEXT;

// +--
// | Print the page header section.
// +--

$step     = $this->CORE->xhtml_translate($this->CORE->globals('importer.step'),'ENCODE');
$steptext = $this->CORE->xhtml_translate($this->CORE->globals('importer.steptext'),'ENCODE');
$numsteps = $this->CORE->xhtml_translate($this->CORE->globals('importer.numsteps'),'ENCODE');

if (($step) && ($steptext)) {

     print '<div id="pgtitle">Step ' . $step . ' of ';
     print $numsteps . ': ' . $steptext;
     print '</div>' . $eol . $eol;

} else {

     print '<div id="pgtitle">Data Importer: ';
     print $this->CORE->xhtml_translate($this->CORE->globals('importer.name'),'ENCODE');
     print '</div>' . $eol . $eol;

} // End of if statement.

// +--
// | Print our content.
// +--

$content = $this->CORE->globals('importer.buffered_output');

print $content;

// +--
// | Print the page footer.
// +--

print <<<ENDOFTEXT

</div>

</body>

</html>

ENDOFTEXT;

// +--
// | Return true.
// +--

return 1;

} // End of function.

// +------------------------------------------------------------------+
// | Function: disp_message                                           |
// +------------------------------------------------------------------+

function disp_message ($message = '',$type = 'ERROR') {

// +--
// | This function prints a message.
// +--

$eol = $this->CORE->globals('core.eol');

// +--
// | If message is blank, return true without printing anything.
// +--

if ($message == '') {return 1;}

// +--
// | Replace full directory paths in the message.
// +--

$pathpriv_quoted = preg_quote($this->CORE->globals('core.path_private'),'/');
$pathpub_quoted  = preg_quote($this->CORE->globals('core.path_public'),'/');

$message = preg_replace('/' . $pathpriv_quoted . '\//','/',$message);
$message = preg_replace('/' . $pathpub_quoted  . '\//','/',$message);

// +--
// | Encode the message.
// +--

$message = $this->CORE->xhtml_translate($message,'ENCODE');

// +--
// | Print the message.
// +--

if ($type == 'ERROR') {

     print '<p class="msgerror">' . $message . '</p>' . $eol . $eol;

} else {

     print '<p class="msgconf">' . $message . '</p>' . $eol . $eol;

} // End of if statement.

// +--
// | Return true.
// +--

return 1;

} // End of function.

// +------------------------------------------------------------------+
// | Function: formdata_array                                         |
// +------------------------------------------------------------------+

function formdata_array ($input = array()) {

// +--
// | This function returns an array of formdata values.  It accepts
// | input in an array with the following format:
// |
// | key:   The formdata field.
// | value: Boolean indicating required status.
// |
// | This function will return an error object if any required fields
// | are not complete.
// +--

$result = array();

if (empty($input)) {return $result;}

$reqnotcomp = 0;

foreach ($input as $key => $value) {

     $xvalue = $this->CORE->globals('core_cgi.' . $key);

     if (!(isset($xvalue))) {$xvalue = '';}

     $result[$key] = $xvalue;

     if ((empty($result[$key])) && (!(empty($value)))) {$reqnotcomp++;}

} // End of foreach statement.

if ($reqnotcomp) {

     $message = "You did not complete all of the required fields before 
                 clicking the 'Continue' button.  Please try again.";

     $result = $this->CORE->RaiseError($message);

     return $result;

} // End of if statement.

// +--
// | Return the result array.
// +--

return $result;

} // End of function.

// +------------------------------------------------------------------+
// | Function: disp_form                                              |
// +------------------------------------------------------------------+

function disp_form ($input = array()) {

// +--
// | This function prints an XHTML form to be used by the importer.
// | 
// | Input is accepted in the form of an array with the following
// | parameters:
// |
// | 'header'   => XHTML header
// |
// | 'step'     => The step to post to.
// |
// | 'supform'  => Optional boolean indicator.  If true the opening 
// |               <form> tag is supressed.  Useful if the header
// |               contains form fields.
// |
// | 'autosub'  => Optional indicator.  If value is 1 this form 
// |               will be auto-submitted.
// |
// | 'fields'   => An array of fields with the following array keys:
// |
// |               'id'       => Form field name.
// |
// |               'name'     => Field display name.
// |
// |               'type'     => Form field type (SELECT, RADIO, HIDDEN
// |                           CHECKBOX, TEXT-REG, TEXT-LONG, PASSWORD)
// |
// |               'desc'     => Pre-formatted XHTML description.
// |
// |               'values'   => An array of values (key = select value,
// |                             value = select display name) for a 
// |                             SELECT, CHECKBOX or RADIO field.
// |
// |               'value'    => A value to use for HIDDEN fields.
// |
// |               'required' => Boolean required indicator.
// +--

$eol = $this->CORE->globals('core.eol');

// +--
// | Set up function variables.
// +--

$header  = (isset($input['header'])  ? $input['header']  : '');
$fields  = (isset($input['fields'])  ? $input['fields']  : array());
$step    = (isset($input['step'])    ? $input['step']    : 'Default');
$supform = (isset($input['supform']) ? $input['supform'] : 0);
$autosub = (isset($input['autosub']) ? $input['autosub'] : 0);

// +--
// | Handle the auto-submit form object.
// +--

if ($autosub == 1) {

     $this->CORE->globals('importer.auto_submit',1);

} // End of if statement.

// +--
// | Print the form header.
// +--

if ($header) {

     print $header . $eol . $eol;

} // End of if statement.

// +--
// | Print the <form> element and required info if not supressed.
// +--

if (empty($supform)) {

     $insname = $this->CORE->globals('importer.script_name');

     print '<form action="' . $insname . '" method="post" id="importer">' . $eol . $eol;

     print '<p>Required fields are marked with a star (*). ';

     if ($autosub == 1) {

          print 'This form should auto-submit itself.  If this does not occur, ';
          print 'click the \'Continue\' button at the bottom of ';
          print 'this page to proceed.</p>' . $eol . $eol;


     } else {

          print 'Click the \'Continue\' button at the bottom of ';
          print 'this page to proceed.</p>' . $eol . $eol;

     } // End of if statement.

} // End of if statement.

// +--
// | Get a list of all of the fields.
// +--

$seen = array();

foreach ($fields as $num => $field) {

     $id = (isset($field['id']) ? $field['id'] : '');

     $seen[$id] = 1;

} // End of foreach statement.

// +--
// | Print the HIDDEN form fields.
// +--

foreach ($fields as $num => $field) {

     $id       = (isset($field['id'])       ? $field['id']       : '');
     $name     = (isset($field['name'])     ? $field['name']     : '');
     $type     = (isset($field['type'])     ? $field['type']     : '');
     $desc     = (isset($field['desc'])     ? $field['desc']     : '');
     $values   = (isset($field['values'])   ? $field['values']   : array());
     $value    = (isset($field['value'])    ? $field['value']    : '');
     $required = (isset($field['required']) ? $field['required'] : '');

     if ($type == 'HIDDEN') {

          $pid    = $this->CORE->xhtml_translate($id,'ENCODE');
          $pvalue = $this->CORE->xhtml_translate($value,'ENCODE');

          print '<p class="hidden"><input type="hidden" name="' . $pid . '" ';
          print 'id="' . $pid . '" value="' . $pvalue . '" /></p>' . $eol . $eol;

     } // End of if statement.

} // End of foreach statement.

// +--
// | Print the ALL OTHER form fields.
// +--

foreach ($fields as $num => $field) {

     $id       = (isset($field['id'])       ? $field['id']       : '');
     $name     = (isset($field['name'])     ? $field['name']     : '');
     $type     = (isset($field['type'])     ? $field['type']     : '');
     $desc     = (isset($field['desc'])     ? $field['desc']     : '');
     $values   = (isset($field['values'])   ? $field['values']   : array());
     $value    = (isset($field['value'])    ? $field['value']    : '');
     $required = (isset($field['required']) ? $field['required'] : '');

     $req = ''; if ($required) {$req = '*';}

     $pvalue = $this->CORE->globals('core_cgi.' . $id); if (empty($pvalue)) {$pvalue = '';}

     $pid    = $this->CORE->xhtml_translate($id,'ENCODE');
     $pname  = $this->CORE->xhtml_translate($name,'ENCODE');

     $xpid   = $pid;

     if (($type == 'CHECKBOX') || ($xpid == 'RADIO')) {$xpid .= '--1';}

     if ($type != 'HIDDEN') {

          print '<fieldset>' . $eol . $eol;

          print '<legend class="strong"><label for="' . $xpid . '">' . $pname . $req;
          print '</label></legend>' . $eol . $eol;

          print '<p class="formfieldleg">' . $pname . $req . '</p>' . $eol . $eol;

          print '<div class="formfieldinstruct">' . $desc . '</div>' . $eol . $eol;

          if (($type == 'TEXT-REG') || ($type == 'TEXT-LONG') || ($type == 'PASSWORD')) {

               $pvalue = $this->CORE->xhtml_translate($pvalue,'ENCODE');

               $size  = '25';   if ($type == 'TEXT-LONG')  {$size = '50';}
               $xtype = 'text'; if ($type == 'PASSWORD')   {$xtype = 'password';}

               print '<input class="formfield" type="' . $xtype . '" ';

               if ($type == 'PASSWORD') {print 'autocomplete="off" ';}

               print 'name="' . $pid . '" id="' . $pid . '" value="';
               print $pvalue . '" size="' . $size . '" />' . $eol . $eol;

          } else {

               if (is_array($pvalue)) {$pvalue = array_flip($pvalue);} else {$pvalue = array($pvalue => 1);}

               if (!(empty($values))) {

                    $count   = 0;
                    $pvalues = array();

                    $made_checked = 0;

                    foreach ($values as $xkey => $xvalue) {

                         $count++;

                         $checked = 0; if (array_key_exists($xkey,$pvalue)) {$checked = 1; $made_checked = 1;}

                         $pvalues[] = array('value'   => $xkey,
                                            'display' => $this->CORE->xhtml_translate($xvalue,'ENCODE'),
                                            'checked' => $checked,
                                            'xid'     => $id . '--' . $count);

                    } // End of foreach statement.

                    if ((!($made_checked)) && ($type == 'RADIO')) {$pvalues[0]['checked'] = 1;}

                    if ($type == 'SELECT') {

                          print '<select class="formfield" name="' . $pid . '" id="' . $pid . '">' . $eol;

                          foreach ($pvalues as $num => $xv) {

                               $checked = ''; if ($xv['checked']) {$checked = ' selected="selected"';}

                               print '<option value="' . $xv['value'] . '" ';
                               print $checked . '>' . $xv['display'] . '</option>' . $eol;

                          } // End of foreach statement.

                          print '</select>' . $eol . $eol;

                    } elseif ($type == 'CHECKBOX') {

                          foreach ($pvalues as $num => $xv) {

                               $checked = ''; if ($xv['checked']) {$checked = ' checked="checked"';}

                               print '<p><input class="formfieldradcb" type="checkbox" name="' . $pid . '[]" ';
                               print 'id="' . $xv['xid'] . '" value="' . $xv['value'] . '"';
                               print $checked . ' />' . ' ' . $xv['display'] . '</p>' . $eol;

                          } // End of foreach statement.

                    } elseif ($type == 'RADIO') {

                          foreach ($pvalues as $num => $xv) {

                               $checked = ''; if ($xv['checked']) {$checked = ' checked="checked"';}

                               print '<p><input class="formfieldradcb" type="radio" name="' . $pid . '" ';
                               print 'id="' . $xv['xid'] . '" value="' . $xv['value'] . '"';
                               print $checked . ' />' . ' ' . $xv['display'] . '</p>' . $eol;

                          } // End of foreach statement.

                    } // End of if statement.

               } // End of if statement.

          } // End of if statement.

          print '</fieldset>' . $eol . $eol;

     } // End of if statement.

} // End of foreach statement.

// +--
// | Print our license_agree, import_password and step fields
// | as well as other fields specific to this importer - if 
// | they weren't seen.
// +--

if (!(array_key_exists('license_agree',$seen))) {

     $value = $this->CORE->globals('core_cgi.license_agree');

     if (is_array($value)) {$value = 1;}

     $value = $this->CORE->xhtml_translate($value,'ENCODE');

     print '<p class="hidden"><input type="hidden" name="license_agree" ';
     print 'id="license_agree" value="' . $value . '" /></p>' . $eol . $eol;

} // End of if statement.

if (!(array_key_exists('import_password',$seen))) {

     $value = $this->CORE->xhtml_translate($this->CORE->globals('core_cgi.import_password'),'ENCODE');

     print '<p class="hidden"><input type="hidden" name="import_password" ';
     print 'id="import_password" value="' . $value . '" /></p>' . $eol . $eol;

} // End of if statement.

if (!(array_key_exists('step',$seen))) {

     print '<p class="hidden"><input type="hidden" name="step" ';
     print 'id="step" value="' . $step . '" /></p>' . $eol . $eol;

} // End of if statement.

if (($autosub == 1) && (!(array_key_exists('auto_submit',$seen)))) {

     print '<p class="hidden"><input type="hidden" name="auto_submit" ';
     print 'id="auto_submit" value="1" /></p>' . $eol . $eol;

} // End of if statement.

if (!(array_key_exists('import_pubconfig',$seen))) {

     $import_pubconfig = $this->CORE->globals('core_cgi.import_pubconfig');
     if (empty($import_pubconfig)) {$import_pubconfig = '';}

     print '<p class="hidden"><input type="hidden" name="import_pubconfig" ';
     print 'id="import_pubconfig" value="' . $import_pubconfig . '" /></p>' . $eol . $eol;

} // End of if statement.

// +--
// | Print the form footer.
// +--

print <<<ENDOFTEXT

<p><input class="formbutton" type="submit" name="SUBMIT" id="SUBMIT" value="Continue" /></p>

</form>

ENDOFTEXT;

// +--
// | Return true.
// +--

return 1;

} // End of function.

// +------------------------------------------------------------------+
// |------------------------------------------------------------------|
// |------------------------------------------------------------------|
// |                                                                  |
// | Multi-Task Form Display                                          |
// |                                                                  |
// |------------------------------------------------------------------|
// |------------------------------------------------------------------|
// +------------------------------------------------------------------+

// +------------------------------------------------------------------+
// | Function: do_multitask                                           |
// +------------------------------------------------------------------+

function do_multitask ($multitask = array()) {

// +--
// | This function presents a multi-task form.
// +--

$eol = $this->CORE->globals('core.eol');

// +--
// | Define our current task.
// +--

$current_task_text = $this->CORE->xhtml_translate($multitask['currtask'],'ENCODE');

// +--
// | Set up the progress bar.
// +--

$progress_bar = '';

$progress_bar_countt  = $multitask['ntaskcount'];
$progress_bar_counti  = $multitask['ntaskcurr'];
$progress_bar_disp    = 50;

$bars_disp= '';
$bars_leftdisp = '';
$bar_count= 0;

$pct = $progress_bar_counti / $progress_bar_countt;
$pct = round($pct,2);

$pct_disp = $pct * 100;

$bars = $progress_bar_disp * $pct;
$bars = round($bars);

while ($bar_count < $bars) {$bar_count++; $bars_disp .= '|';}

$bars_left = $progress_bar_disp - $bars;

$bar_count = 0;

while ($bar_count < $bars_left) {$bar_count++; $bars_leftdisp .= '|';}

$pct_leftdisp = 100 - $pct_disp;

$progress_bar  = '<p class="meter">Progress: </p>';

if ($bars) {$progress_bar .= '<p class="metercomp">' . $bars_disp . '</p>';}

if ($bars_left) {$progress_bar .= '<p class="meterpend">' . $bars_leftdisp . '</p>';}

$progress_bar .= '<p class="meter"> [' . $pct_disp . '%]</p>' . $eol . $eol;

$header = <<<ENDOFTEXT

<p>You have selected to process a multi-task operation.  If this page does 
not automatically refresh itself within one second, click the 'Continue' 
button to proceed.</p>

ENDOFTEXT;

$insname = $this->CORE->globals('importer.script_name');

$header .= '<form action="' . $insname . '" method="post" id="importer">' . $eol . $eol;

$header .= <<<ENDOFTEXT

<fieldset>

<legend class="strong"><label for="taskdo">Task Status</label></legend>

<p class="formfieldleg">Task Status</p>

<div class="formfieldinstruct">

<p>The progress meter below displays your progress during this multi-task operation.</p>

<div id='meter'>{$progress_bar}</div>

</div>

<p class="hidden"><input type="hidden" name="taskstatus" id="taskstatus" value="1" /></p>

</fieldset>

<fieldset>

<legend class="strong"><label for="currenttask">Current Task</label></legend>

<p class="formfieldleg">Current Task</p>

<div class="formfieldinstruct">

<p>{$current_task_text}</p>

</div>

<p class="hidden"><input type="hidden" name="currenttask" id="currenttask" value="1" /></p>

</fieldset>

ENDOFTEXT;

// +--
// | Formulate the form fields.
// +--

$fields[0]['id']       = 'offset';
$fields[0]['type']     = 'HIDDEN';
$fields[0]['required'] = 0;
$fields[0]['value']    = $multitask['offset'];

$fields[1]['id']       = 'import_do';
$fields[1]['type']     = 'HIDDEN';
$fields[1]['required'] = 0;
$fields[1]['value']    = 1;

if (!(empty($multitask['mtcomplete']))) {

     $fields[2]['id']       = 'mtcomplete';
     $fields[2]['type']     = 'HIDDEN';
     $fields[2]['required'] = 0;
     $fields[2]['value']    = 1;

} // End of if statement.

// +--
// | Print the form.
// +--

$this->disp_form(array('header'   => $header,
                       'fields'   => $fields,
                       'step'     => $multitask['currstep'],
                       'supform'  => 1,
                       'autosub'  => 1));

// +--
// | Return true.
// +--

return 1;

} // End of function.

// +------------------------------------------------------------------+
// |------------------------------------------------------------------|
// |------------------------------------------------------------------|
// |                                                                  |
// | Importer Common Functions                                        |
// |                                                                  |
// |------------------------------------------------------------------|
// |------------------------------------------------------------------|
// +------------------------------------------------------------------+

// +------------------------------------------------------------------+
// | Function: import_count_rows                                      |
// +------------------------------------------------------------------+

function import_count_rows ($table = '') {

// +--
// | This function counts the rows in a table and returns the count.
// +--

// +--
// | Return an error if we weren't passed a table to load.
// +--

if (empty($table)) {return 0;}

// +--
// | Get the count.
// +--

$count = $this->CORE_DBX->sql_count(array('table' => $table));

if (($this->CORE->IsError($count)) || (empty($count))) {$count = 0;}

return $count;

// +--
// | Return the count.
// +--

return $count;

} // End of function.

// +------------------------------------------------------------------+
// | Function: import_load_data                                       |
// +------------------------------------------------------------------+

function import_load_data ($table = '',$offset = 0,$count = 100) {

// +--
// | This function loads data from a table.  It returns a DB-like
// | array.
// +--

// +--
// | Return an error if we weren't passed a table to load or 
// | table definition information.
// +--

if (empty($table)) {return array();}

// +--
// | Load the data.
// +--

$columns = $this->CORE_DBX->table_column_string($table);

if ($this->CORE->IsError($columns)) {return array();}

$sql  = "SELECT {$columns} FROM {$table}";

if ($count == 'ALL') {

     $data = $this->CORE_DBX->sql_do(array('sql'    => $sql,
                                           'table'  => $table,
                                           'order'  => array('id' => 'ASC')));

} else {

     $data = $this->CORE_DBX->sql_do(array('sql'    => $sql,
                                           'table'  => $table,
                                           'order'  => array('id' => 'ASC'),
                                           'count'  => $count,
                                           'offset' => $offset));

} // End of if statement.

// +--
// | Handle errors.
// +--

if ($this->CORE->IsError($data)) {return array();}

// +--
// | Return the data.
// +--

return $data;

} // End of function.

// +------------------------------------------------------------------+
// | Function: import_load_configphp                                  |
// +------------------------------------------------------------------+

function import_load_configphp ($configphp = '') {

// +--
// | Loads configuration files from an install to be imported from.
// +--

if ((empty($configphp)) || (!(@file_exists($configphp)))) {return false;}

// +--
// | Load public configuration.
// +--

$config = array();

@include($configphp);

if (empty($config)) {return false;}

foreach ($config as $key => $value) {

     if (preg_match('/^khxc\./',$key)) {

          $key = preg_replace('/^khxc\./','importer.import_',$key);

          $this->CORE->globals($key,$value);

     } // End of if statement.

} // End of foreach statement.

unset($config);

$testvar = $this->CORE->globals('importer.import_path_private');

if (empty($testvar)) {return false;}

// +--
// | Load private configuration.
// +--

$configphp = $testvar . '/config.php';

$config = array();

@include($configphp);

if (empty($config)) {return false;}

foreach ($config as $key => $value) {

     if (preg_match('/^khxc\./',$key)) {

          $key = preg_replace('/^khxc\./','importer.import_',$key);

          $this->CORE->globals($key,$value);

     } // End of if statement.

} // End of foreach statement.

$testvar = $this->CORE->globals('importer.import_password_copy');

if (empty($testvar)) {return false;}

// +--
// | Return true.
// +--

return 1;

} // End of function.

// +------------------------------------------------------------------+
// | Function: import_connect_db                                      |
// +------------------------------------------------------------------+

function import_connect_db () {

// +--
// | Loads a connection as $this->CORE_DBX to the database being
// | imported from.
// +--

$dbtype   = $this->CORE->globals('importer.import_db_dbtype');
$hostname = $this->CORE->globals('importer.import_db_hostname');
$dbname   = $this->CORE->globals('importer.import_db_dbname');
$username = $this->CORE->globals('importer.import_db_username');
$password = $this->CORE->globals('importer.import_db_password');

$dsn = array('dbtype'   => $dbtype,
             'username' => $username,
             'password' => $password,
             'hostname' => $hostname,
             'dbname'   => $dbname);

// +--
// | Attempt to load CORE_DB using an alternate handle.
// +--

$this->CORE_DBX =& $this->CORE->load_object(array('app'       => 'core',
                                                  'class'     => 'CORE_DB',
                                                  'name'      => 'CORE_DB_2',
                                                  'construct' => $dsn));

// +--
// | Handle constructor errors.
// +--

if ($this->CORE->IsError($this->CORE_DBX)) {return false;}

// +--
// | Connect and handle errors.
// +--

$result = $this->CORE_DBX->connect();

if ($this->CORE->IsError($result)) {return false;}

// +--
// | Return true.
// +--

return 1;

} // End of function.

// +------------------------------------------------------------------+
// | Function: import_define_db                                       |
// +------------------------------------------------------------------+

function import_define_db () {

// +--
// | Defines some parameters we're going to need throughout 
// | execution of this script.
// +--

$ecomapp   = '';
$settings  = array();

$sql  = "SELECT id,value FROM khxc_settings";

$result= $this->CORE_DBX->sql_do(array('sql'   => $sql,
                                       'table' => 'khxc_settings',
                                       'order' => array('id' => 'ASC')));

if (($this->CORE->IsError($result)) || (empty($result))) {return false;}

foreach ($result as $num => $data) {$settings[$data['id']] = $data['value'];}

// +--
// | Set our ecomapp variable based on the settings we saw.
// +--

if (!(empty($settings['gbu0.cron_daily_last']))) {$ecomapp = 'gbu0';}
if (!(empty($settings['ccp0.cron_daily_last']))) {$ecomapp = 'ccp0';}

if (empty($ecomapp)) {return false;}

// +--
// | Globalize our settings and ecomapp.
// +--

$this->CORE->globals('importer.import_db_settings',$settings);
$this->CORE->globals('importer.import_db_ecomapp',$ecomapp);

// +--
// | Return true.
// +--

return 1;

} // End of function.

// +------------------------------------------------------------------+
// | Function: import_fix_content                                     |
// +------------------------------------------------------------------+

function import_fix_content ($content = '') {

// +--
// | Fixes General content.
// +--

if (empty($content)) {return $content;}

$content = preg_replace('/' . preg_quote('class="khxc_','/') . '/','class="',$content);
$content = preg_replace('/' . preg_quote('div id="khxc_','/') . '/','div id="',$content);
$content = preg_replace('/KHXC/s','CORE',$content);
$content = preg_replace('/khxc/s','core',$content);
$content = preg_replace('/ccp0/s','ecom',$content);
$content = preg_replace('/gbu0/s','ecom',$content);
$content = preg_replace('/bkd0/s','cms',$content);

$content = preg_replace('/' . preg_quote('\'ecom\',\'display\'') . '/','\'cms\',\'display\'',$content);
$content = preg_replace('/' . preg_quote('\'ecom\', \'display\'') . '/','\'cms\', \'display\'',$content);
$content = preg_replace('/' . preg_quote('ecom-display') . '/','cms-display',$content);

$content = preg_replace('/' . preg_quote('\'ecom\',\'dynform\'') . '/','\'cms\',\'dynform\'',$content);
$content = preg_replace('/' . preg_quote('\'ecom\', \'dynform\'') . '/','\'cms\', \'dynform\'',$content);
$content = preg_replace('/' . preg_quote('ecom-dynform') . '/','cms-dynform',$content);

$content = preg_replace('/' . preg_quote('\'cms\',\'prodfeature\'') . '/','\'ecom\',\'prodfeature\'',$content);
$content = preg_replace('/' . preg_quote('\'cms\', \'prodfeature\'') . '/','\'ecom\', \'prodfeature\'',$content);
$content = preg_replace('/' . preg_quote('cms-prodfeature') . '/','ecom-prodfeature',$content);

// +--
// | Return content.
// +--

return $content;

} // End of function.

// +------------------------------------------------------------------+
// | End of Class                                                     |
// +------------------------------------------------------------------+

} // End of class.

// +------------------------------------------------------------------+
// | End Of File                                                      |
// +------------------------------------------------------------------+

?>